/* EllipsisCheck.c generated by valac 0.56.3, the Vala compiler
 * generated from EllipsisCheck.vala, do not modify */

/*
 * Copyright (c) 2016-2019 elementary LLC. (https://github.com/elementary/vala-lint)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */

#include "vala-linter.h"
#include <valagee.h>
#include <glib-object.h>
#include <vala.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>

#define VALA_LINT_CHECKS_ELLIPSIS_CHECK_ELLIPSIS "..."
#define VALA_LINT_CHECKS_ELLIPSIS_CHECK_REAL_ELLIPSIS "…"

enum  {
	VALA_LINT_CHECKS_ELLIPSIS_CHECK_0_PROPERTY,
	VALA_LINT_CHECKS_ELLIPSIS_CHECK_NUM_PROPERTIES
};
static GParamSpec* vala_lint_checks_ellipsis_check_properties[VALA_LINT_CHECKS_ELLIPSIS_CHECK_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

static gpointer vala_lint_checks_ellipsis_check_parent_class = NULL;

static void vala_lint_checks_ellipsis_check_real_check (ValaLintCheck* base,
                                                 ValaArrayList* parse_result,
                                                 ValaArrayList** mistake_list);
static gboolean vala_lint_checks_ellipsis_check_real_apply_fix (ValaLintCheck* base,
                                                         ValaSourceLocation* begin,
                                                         ValaSourceLocation* end,
                                                         gchar** contents);
static GType vala_lint_checks_ellipsis_check_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

ValaLintChecksEllipsisCheck*
vala_lint_checks_ellipsis_check_construct (GType object_type)
{
	ValaLintChecksEllipsisCheck * self = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	self = (ValaLintChecksEllipsisCheck*) g_object_new (object_type, "title", "ellipsis", "description", _ ("Checks for ellipsis character instead of three periods"), NULL);
	_tmp0_ = vala_lint_check_get_title ((ValaLintCheck*) self);
	_tmp1_ = _tmp0_;
	vala_lint_check_set_state ((ValaLintCheck*) self, vala_lint_config_get_state (_tmp1_));
	return self;
}

ValaLintChecksEllipsisCheck*
vala_lint_checks_ellipsis_check_new (void)
{
	return vala_lint_checks_ellipsis_check_construct (VALA_LINT_CHECKS_TYPE_ELLIPSIS_CHECK);
}

static void
vala_lint_checks_ellipsis_check_real_check (ValaLintCheck* base,
                                            ValaArrayList* parse_result,
                                            ValaArrayList** mistake_list)
{
	ValaLintChecksEllipsisCheck * self;
	self = (ValaLintChecksEllipsisCheck*) base;
	g_return_if_fail (parse_result != NULL);
	g_return_if_fail (*mistake_list != NULL);
}

static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (needle != NULL, 0);
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	if (_tmp1_ != NULL) {
		gchar* _tmp2_;
		_tmp2_ = _result_;
		result = (gint) (_tmp2_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}

void
vala_lint_checks_ellipsis_check_check_string_literal (ValaLintChecksEllipsisCheck* self,
                                                      ValaStringLiteral* lit,
                                                      ValaArrayList** mistake_list)
{
	ValaLintConfigState _tmp0_;
	ValaLintConfigState _tmp1_;
	gint index = 0;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (lit != NULL);
	g_return_if_fail (*mistake_list != NULL);
	_tmp0_ = vala_lint_check_get_state ((ValaLintCheck*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == VALA_LINT_CONFIG_STATE_OFF) {
		return;
	}
	_tmp2_ = vala_string_literal_get_value (lit);
	_tmp3_ = _tmp2_;
	index = string_index_of (_tmp3_, VALA_LINT_CHECKS_ELLIPSIS_CHECK_ELLIPSIS, 0);
	while (TRUE) {
		ValaSourceLocation begin = {0};
		ValaSourceReference* _tmp4_;
		ValaSourceReference* _tmp5_;
		ValaSourceLocation _tmp6_ = {0};
		ValaSourceLocation _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		ValaSourceLocation _tmp10_ = {0};
		gint length = 0;
		ValaSourceLocation end = {0};
		ValaSourceLocation _tmp13_;
		ValaSourceLocation _tmp14_ = {0};
		ValaSourceLocation _tmp15_;
		ValaSourceLocation _tmp16_;
		ValaLintFormatMistake _tmp17_ = {0};
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		if (!(index > -1)) {
			break;
		}
		_tmp4_ = vala_code_node_get_source_reference ((ValaCodeNode*) lit);
		_tmp5_ = _tmp4_;
		vala_source_reference_get_begin (_tmp5_, &_tmp6_);
		_tmp7_ = _tmp6_;
		_tmp8_ = vala_string_literal_get_value (lit);
		_tmp9_ = _tmp8_;
		vala_lint_utils_get_absolute_location (&_tmp7_, _tmp9_, index, &_tmp10_);
		begin = _tmp10_;
		length = 0;
		while (TRUE) {
			const gchar* _tmp11_;
			const gchar* _tmp12_;
			_tmp11_ = vala_string_literal_get_value (lit);
			_tmp12_ = _tmp11_;
			if (!(string_get (_tmp12_, (glong) (index + length)) == '.')) {
				break;
			}
			length += 1;
		}
		_tmp13_ = begin;
		vala_lint_utils_shift_location (&_tmp13_, length, &_tmp14_);
		end = _tmp14_;
		_tmp15_ = begin;
		_tmp16_ = end;
		_g_object_unref0 (_tmp17_.check);
		_tmp17_.check = (ValaLintCheck*) self;
		_tmp17_.begin = _tmp15_;
		_tmp17_.end = _tmp16_;
		_g_free0 (_tmp17_.mistake);
		_tmp17_.mistake = _ ("Expected ellipsis instead of periods");
		vala_lint_check_add_mistake ((ValaLintCheck*) self, &_tmp17_, mistake_list);
		_tmp18_ = vala_string_literal_get_value (lit);
		_tmp19_ = _tmp18_;
		index = string_index_of (_tmp19_, VALA_LINT_CHECKS_ELLIPSIS_CHECK_ELLIPSIS, index + length);
	}
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	if (start < ((glong) 0)) {
		start = string_length + start;
	}
	if (end < ((glong) 0)) {
		end = string_length + end;
	}
	if (start >= ((glong) 0)) {
		_tmp2_ = start <= string_length;
	} else {
		_tmp2_ = FALSE;
	}
	g_return_val_if_fail (_tmp2_, NULL);
	if (end >= ((glong) 0)) {
		_tmp3_ = end <= string_length;
	} else {
		_tmp3_ = FALSE;
	}
	g_return_val_if_fail (_tmp3_, NULL);
	g_return_val_if_fail (start <= end, NULL);
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
	result = _tmp4_;
	return result;
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
	if (separator == NULL) {
		separator = "";
	}
	if (str_array != NULL) {
		gboolean _tmp1_ = FALSE;
		if (str_array_length1 > 0) {
			_tmp1_ = TRUE;
		} else {
			gboolean _tmp2_ = FALSE;
			if (str_array_length1 == -1) {
				const gchar* _tmp3_;
				_tmp3_ = str_array[0];
				_tmp2_ = _tmp3_ != NULL;
			} else {
				_tmp2_ = FALSE;
			}
			_tmp1_ = _tmp2_;
		}
		_tmp0_ = _tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
		len = (gsize) 1;
		{
			gboolean _tmp4_ = FALSE;
			i = 0;
			_tmp4_ = TRUE;
			while (TRUE) {
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				if (str_array_length1 != -1) {
					_tmp7_ = i < str_array_length1;
				} else {
					_tmp7_ = FALSE;
				}
				if (_tmp7_) {
					_tmp6_ = TRUE;
				} else {
					gboolean _tmp8_ = FALSE;
					if (str_array_length1 == -1) {
						const gchar* _tmp9_;
						_tmp9_ = str_array[i];
						_tmp8_ = _tmp9_ != NULL;
					} else {
						_tmp8_ = FALSE;
					}
					_tmp6_ = _tmp8_;
				}
				if (!_tmp6_) {
					break;
				}
				_tmp11_ = str_array[i];
				if (_tmp11_ != NULL) {
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
					_tmp12_ = str_array[i];
					_tmp13_ = strlen ((const gchar*) _tmp12_);
					_tmp14_ = _tmp13_;
					_tmp10_ = _tmp14_;
				} else {
					_tmp10_ = 0;
				}
				len += (gsize) _tmp10_;
			}
		}
		if (i == 0) {
			gchar* _tmp15_;
			_tmp15_ = g_strdup ("");
			result = _tmp15_;
			return result;
		}
		str_array_length1 = i;
		_tmp16_ = strlen ((const gchar*) separator);
		_tmp17_ = _tmp16_;
		len += (gsize) (_tmp17_ * (i - 1));
		_tmp18_ = g_malloc (len);
		res = _tmp18_;
		_tmp20_ = str_array[0];
		if (_tmp20_ != NULL) {
			const gchar* _tmp21_;
			_tmp21_ = str_array[0];
			_tmp19_ = (const gchar*) _tmp21_;
		} else {
			_tmp19_ = "";
		}
		_tmp22_ = res;
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
		ptr = _tmp23_;
		{
			gboolean _tmp24_ = FALSE;
			i = 1;
			_tmp24_ = TRUE;
			while (TRUE) {
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
				if (!_tmp24_) {
					gint _tmp25_;
					_tmp25_ = i;
					i = _tmp25_ + 1;
				}
				_tmp24_ = FALSE;
				if (!(i < str_array_length1)) {
					break;
				}
				_tmp26_ = ptr;
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
				ptr = _tmp27_;
				_tmp29_ = str_array[i];
				if (_tmp29_ != NULL) {
					const gchar* _tmp30_;
					_tmp30_ = str_array[i];
					_tmp28_ = (const gchar*) _tmp30_;
				} else {
					_tmp28_ = "";
				}
				_tmp31_ = ptr;
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
				ptr = _tmp32_;
			}
		}
		_tmp33_ = res;
		res = NULL;
		result = (gchar*) _tmp33_;
		return result;
	} else {
		gchar* _tmp34_;
		_tmp34_ = g_strdup ("");
		result = _tmp34_;
		return result;
	}
}

static gboolean
vala_lint_checks_ellipsis_check_real_apply_fix (ValaLintCheck* base,
                                                ValaSourceLocation* begin,
                                                ValaSourceLocation* end,
                                                gchar** contents)
{
	ValaLintChecksEllipsisCheck * self;
	gchar** lines = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint lines_length1;
	gint _lines_size_;
	gchar* line = NULL;
	ValaSourceLocation _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	ValaSourceLocation _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	ValaSourceLocation _tmp12_;
	const gchar* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	ValaSourceLocation _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gboolean result;
	self = (ValaLintChecksEllipsisCheck*) base;
	g_return_val_if_fail (begin != NULL, FALSE);
	g_return_val_if_fail (end != NULL, FALSE);
	g_return_val_if_fail (*contents != NULL, FALSE);
	_tmp1_ = _tmp0_ = g_strsplit (*contents, "\n", 0);
	lines = _tmp1_;
	lines_length1 = _vala_array_length (_tmp0_);
	_lines_size_ = lines_length1;
	_tmp2_ = *begin;
	_tmp3_ = lines[_tmp2_.line - 1];
	_tmp4_ = g_strdup (_tmp3_);
	line = _tmp4_;
	_tmp5_ = line;
	_tmp6_ = *begin;
	_tmp7_ = string_slice (_tmp5_, (glong) 0, (glong) (_tmp6_.column - 1));
	_tmp8_ = _tmp7_;
	_tmp9_ = g_strconcat (_tmp8_, VALA_LINT_CHECKS_ELLIPSIS_CHECK_REAL_ELLIPSIS, NULL);
	_tmp10_ = _tmp9_;
	_tmp11_ = line;
	_tmp12_ = *end;
	_tmp13_ = line;
	_tmp14_ = strlen (_tmp13_);
	_tmp15_ = _tmp14_;
	_tmp16_ = string_slice (_tmp11_, (glong) (_tmp12_.column - 1), (glong) _tmp15_);
	_tmp17_ = _tmp16_;
	_tmp18_ = g_strconcat (_tmp10_, _tmp17_, NULL);
	_g_free0 (line);
	line = _tmp18_;
	_g_free0 (_tmp17_);
	_g_free0 (_tmp10_);
	_g_free0 (_tmp8_);
	_tmp19_ = *begin;
	_tmp20_ = line;
	_tmp21_ = g_strdup (_tmp20_);
	_g_free0 (lines[_tmp19_.line - 1]);
	lines[_tmp19_.line - 1] = _tmp21_;
	_tmp22_ = _vala_g_strjoinv ("\n", lines, (gint) lines_length1);
	_g_free0 (*contents);
	*contents = _tmp22_;
	result = TRUE;
	_g_free0 (line);
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

static void
vala_lint_checks_ellipsis_check_class_init (ValaLintChecksEllipsisCheckClass * klass,
                                            gpointer klass_data)
{
	vala_lint_checks_ellipsis_check_parent_class = g_type_class_peek_parent (klass);
	((ValaLintCheckClass *) klass)->check = (void (*) (ValaLintCheck*, ValaArrayList*, ValaArrayList**)) vala_lint_checks_ellipsis_check_real_check;
	((ValaLintCheckClass *) klass)->apply_fix = (gboolean (*) (ValaLintCheck*, ValaSourceLocation*, ValaSourceLocation*, gchar**)) vala_lint_checks_ellipsis_check_real_apply_fix;
}

static void
vala_lint_checks_ellipsis_check_instance_init (ValaLintChecksEllipsisCheck * self,
                                               gpointer klass)
{
}

static GType
vala_lint_checks_ellipsis_check_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ValaLintChecksEllipsisCheckClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_lint_checks_ellipsis_check_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaLintChecksEllipsisCheck), 0, (GInstanceInitFunc) vala_lint_checks_ellipsis_check_instance_init, NULL };
	GType vala_lint_checks_ellipsis_check_type_id;
	vala_lint_checks_ellipsis_check_type_id = g_type_register_static (VALA_LINT_TYPE_CHECK, "ValaLintChecksEllipsisCheck", &g_define_type_info, 0);
	return vala_lint_checks_ellipsis_check_type_id;
}

GType
vala_lint_checks_ellipsis_check_get_type (void)
{
	static volatile gsize vala_lint_checks_ellipsis_check_type_id__once = 0;
	if (g_once_init_enter (&vala_lint_checks_ellipsis_check_type_id__once)) {
		GType vala_lint_checks_ellipsis_check_type_id;
		vala_lint_checks_ellipsis_check_type_id = vala_lint_checks_ellipsis_check_get_type_once ();
		g_once_init_leave (&vala_lint_checks_ellipsis_check_type_id__once, vala_lint_checks_ellipsis_check_type_id);
	}
	return vala_lint_checks_ellipsis_check_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

