/* LineLengthCheck.c generated by valac 0.56.3, the Vala compiler
 * generated from LineLengthCheck.vala, do not modify */

/*
 * Copyright (c) 2018-2019 elementary LLC. (https://github.com/elementary/vala-lint)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */

#include "vala-linter.h"
#include <glib.h>
#include <valagee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <vala.h>

#define VALA_LINT_CHECKS_LINE_LENGTH_CHECK_MESSAGE _ ("Line exceeds limit of %d characters (currently %d characters)")

enum  {
	VALA_LINT_CHECKS_LINE_LENGTH_CHECK_0_PROPERTY,
	VALA_LINT_CHECKS_LINE_LENGTH_CHECK_MAXIMUM_CHARACTERS_PROPERTY,
	VALA_LINT_CHECKS_LINE_LENGTH_CHECK_IGNORE_COMMENTS_PROPERTY,
	VALA_LINT_CHECKS_LINE_LENGTH_CHECK_NUM_PROPERTIES
};
static GParamSpec* vala_lint_checks_line_length_check_properties[VALA_LINT_CHECKS_LINE_LENGTH_CHECK_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _parse_result_free0(var) ((var == NULL) ? NULL : (var = (parse_result_free (var), NULL)))

struct _ValaLintChecksLineLengthCheckPrivate {
	gint _maximum_characters;
	gboolean _ignore_comments;
};

static gint ValaLintChecksLineLengthCheck_private_offset;
static gpointer vala_lint_checks_line_length_check_parent_class = NULL;

static void vala_lint_checks_line_length_check_real_check (ValaLintCheck* base,
                                                    ValaArrayList* parse_result,
                                                    ValaArrayList** mistake_list);
static void vala_lint_checks_line_length_check_finalize (GObject * obj);
static GType vala_lint_checks_line_length_check_get_type_once (void);
static void _vala_vala_lint_checks_line_length_check_get_property (GObject * object,
                                                            guint property_id,
                                                            GValue * value,
                                                            GParamSpec * pspec);
static void _vala_vala_lint_checks_line_length_check_set_property (GObject * object,
                                                            guint property_id,
                                                            const GValue * value,
                                                            GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
vala_lint_checks_line_length_check_get_instance_private (ValaLintChecksLineLengthCheck* self)
{
	return G_STRUCT_MEMBER_P (self, ValaLintChecksLineLengthCheck_private_offset);
}

ValaLintChecksLineLengthCheck*
vala_lint_checks_line_length_check_construct (GType object_type)
{
	ValaLintChecksLineLengthCheck * self = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	self = (ValaLintChecksLineLengthCheck*) g_object_new (object_type, "title", "line-length", "description", _ ("Checks for a maxmimum line legnth"), NULL);
	_tmp0_ = vala_lint_check_get_title ((ValaLintCheck*) self);
	_tmp1_ = _tmp0_;
	vala_lint_check_set_state ((ValaLintCheck*) self, vala_lint_config_get_state (_tmp1_));
	_tmp2_ = vala_lint_check_get_title ((ValaLintCheck*) self);
	_tmp3_ = _tmp2_;
	vala_lint_checks_line_length_check_set_maximum_characters (self, vala_lint_config_get_integer (_tmp3_, "max-line-length"));
	_tmp4_ = vala_lint_check_get_title ((ValaLintCheck*) self);
	_tmp5_ = _tmp4_;
	vala_lint_checks_line_length_check_set_ignore_comments (self, vala_lint_config_get_boolean (_tmp5_, "ignore-comments"));
	return self;
}

ValaLintChecksLineLengthCheck*
vala_lint_checks_line_length_check_new (void)
{
	return vala_lint_checks_line_length_check_construct (VALA_LINT_CHECKS_TYPE_LINE_LENGTH_CHECK);
}

void
vala_lint_checks_line_length_check_check_line (ValaLintChecksLineLengthCheck* self,
                                               const gchar* line,
                                               gint line_count,
                                               ValaArrayList** mistake_list)
{
	gint line_length = 0;
	gint _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (line != NULL);
	g_return_if_fail (*mistake_list != NULL);
	line_length = g_utf8_strlen (line, (gssize) -1);
	_tmp0_ = self->priv->_maximum_characters;
	if (line_length > _tmp0_) {
		gchar* formatted_message = NULL;
		gint _tmp1_;
		gchar* _tmp2_;
		gchar* pos = NULL;
		ValaSourceLocation begin = {0};
		gchar* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		ValaSourceLocation end = {0};
		gchar* _tmp6_;
		ValaSourceLocation _tmp7_;
		ValaSourceLocation _tmp8_;
		const gchar* _tmp9_;
		ValaLintFormatMistake _tmp10_ = {0};
		_tmp1_ = self->priv->_maximum_characters;
		_tmp2_ = g_strdup_printf (VALA_LINT_CHECKS_LINE_LENGTH_CHECK_MESSAGE, _tmp1_, line_length);
		formatted_message = _tmp2_;
		pos = (gchar*) line;
		_tmp3_ = pos;
		_tmp4_ = self->priv->_maximum_characters;
		_tmp5_ = self->priv->_maximum_characters;
		vala_source_location_init (&begin, _tmp3_ + _tmp4_, line_count, _tmp5_);
		_tmp6_ = pos;
		vala_source_location_init (&end, _tmp6_ + line_length, line_count, line_length);
		_tmp7_ = begin;
		_tmp8_ = end;
		_tmp9_ = formatted_message;
		_g_object_unref0 (_tmp10_.check);
		_tmp10_.check = (ValaLintCheck*) self;
		_tmp10_.begin = _tmp7_;
		_tmp10_.end = _tmp8_;
		_g_free0 (_tmp10_.mistake);
		_tmp10_.mistake = _tmp9_;
		vala_lint_check_add_mistake ((ValaLintCheck*) self, &_tmp10_, mistake_list);
		_g_free0 (formatted_message);
	}
}

static void
vala_lint_checks_line_length_check_real_check (ValaLintCheck* base,
                                               ValaArrayList* parse_result,
                                               ValaArrayList** mistake_list)
{
	ValaLintChecksLineLengthCheck * self;
	gchar* line = NULL;
	gchar* _tmp0_;
	ParseResult* r = NULL;
	gpointer _tmp38_;
	const gchar* _tmp39_;
	ValaSourceLocation _tmp40_;
	self = (ValaLintChecksLineLengthCheck*) base;
	g_return_if_fail (parse_result != NULL);
	g_return_if_fail (*mistake_list != NULL);
	_tmp0_ = g_strdup ("");
	line = _tmp0_;
	{
		ValaArrayList* _r_list = NULL;
		gint _r_size = 0;
		ValaArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _r_index = 0;
		_r_list = parse_result;
		_tmp1_ = _r_list;
		_tmp2_ = vala_collection_get_size ((ValaCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_r_size = _tmp3_;
		_r_index = -1;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			ParseResult r = {0};
			ValaArrayList* _tmp6_;
			gpointer _tmp7_;
			ParseResult* _tmp8_;
			ParseResult _tmp9_;
			ParseResult _tmp10_ = {0};
			ParseResult _tmp11_;
			gchar** text_split = NULL;
			ParseResult _tmp12_;
			const gchar* _tmp13_;
			gchar** _tmp14_;
			gchar** _tmp15_;
			gint text_split_length1;
			gint _text_split_size_;
			gboolean _tmp30_ = FALSE;
			ParseResult _tmp31_;
			_r_index = _r_index + 1;
			_tmp4_ = _r_index;
			_tmp5_ = _r_size;
			if (!(_tmp4_ < _tmp5_)) {
				break;
			}
			_tmp6_ = _r_list;
			_tmp7_ = vala_list_get ((ValaList*) _tmp6_, _r_index);
			_tmp8_ = (ParseResult*) _tmp7_;
			_tmp9_ = *_tmp8_;
			parse_result_copy (&_tmp9_, &_tmp10_);
			_tmp11_ = _tmp10_;
			_parse_result_free0 (_tmp8_);
			r = _tmp11_;
			_tmp12_ = r;
			_tmp13_ = _tmp12_.text;
			_tmp15_ = _tmp14_ = g_strsplit (_tmp13_, "\n", 0);
			text_split = _tmp15_;
			text_split_length1 = _vala_array_length (_tmp14_);
			_text_split_size_ = text_split_length1;
			{
				gint i = 0;
				i = 0;
				{
					gboolean _tmp16_ = FALSE;
					_tmp16_ = TRUE;
					while (TRUE) {
						gchar** _tmp18_;
						gint _tmp18__length1;
						gboolean _tmp19_ = FALSE;
						ParseResult _tmp20_;
						const gchar* _tmp26_;
						ParseResult _tmp27_;
						ValaSourceLocation _tmp28_;
						gchar* _tmp29_;
						if (!_tmp16_) {
							gint _tmp17_;
							_tmp17_ = i;
							i = _tmp17_ + 1;
						}
						_tmp16_ = FALSE;
						_tmp18_ = text_split;
						_tmp18__length1 = text_split_length1;
						if (!(i < (_tmp18__length1 - 1))) {
							break;
						}
						_tmp20_ = r;
						if (_tmp20_.type != PARSE_TYPE_COMMENT) {
							_tmp19_ = TRUE;
						} else {
							gboolean _tmp21_;
							_tmp21_ = self->priv->_ignore_comments;
							_tmp19_ = !_tmp21_;
						}
						if (_tmp19_) {
							const gchar* _tmp22_;
							gchar** _tmp23_;
							gint _tmp23__length1;
							const gchar* _tmp24_;
							gchar* _tmp25_;
							_tmp22_ = line;
							_tmp23_ = text_split;
							_tmp23__length1 = text_split_length1;
							_tmp24_ = _tmp23_[i];
							_tmp25_ = g_strconcat (_tmp22_, _tmp24_, NULL);
							_g_free0 (line);
							line = _tmp25_;
						}
						_tmp26_ = line;
						_tmp27_ = r;
						_tmp28_ = _tmp27_.begin;
						vala_lint_checks_line_length_check_check_line (self, _tmp26_, _tmp28_.line + i, mistake_list);
						_tmp29_ = g_strdup ("");
						_g_free0 (line);
						line = _tmp29_;
					}
				}
			}
			_tmp31_ = r;
			if (_tmp31_.type != PARSE_TYPE_COMMENT) {
				_tmp30_ = TRUE;
			} else {
				gboolean _tmp32_;
				_tmp32_ = self->priv->_ignore_comments;
				_tmp30_ = !_tmp32_;
			}
			if (_tmp30_) {
				const gchar* _tmp33_;
				gchar** _tmp34_;
				gint _tmp34__length1;
				gchar** _tmp35_;
				gint _tmp35__length1;
				const gchar* _tmp36_;
				gchar* _tmp37_;
				_tmp33_ = line;
				_tmp34_ = text_split;
				_tmp34__length1 = text_split_length1;
				_tmp35_ = text_split;
				_tmp35__length1 = text_split_length1;
				_tmp36_ = _tmp34_[_tmp35__length1 - 1];
				_tmp37_ = g_strconcat (_tmp33_, _tmp36_, NULL);
				_g_free0 (line);
				line = _tmp37_;
			}
			text_split = (_vala_array_free (text_split, text_split_length1, (GDestroyNotify) g_free), NULL);
			parse_result_destroy (&r);
		}
	}
	_tmp38_ = vala_list_last ((ValaList*) parse_result);
	r = (ParseResult*) _tmp38_;
	_tmp39_ = line;
	_tmp40_ = (*r).begin;
	vala_lint_checks_line_length_check_check_line (self, _tmp39_, _tmp40_.line, mistake_list);
	_parse_result_free0 (r);
	_g_free0 (line);
}

gint
vala_lint_checks_line_length_check_get_maximum_characters (ValaLintChecksLineLengthCheck* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_maximum_characters;
	return result;
}

void
vala_lint_checks_line_length_check_set_maximum_characters (ValaLintChecksLineLengthCheck* self,
                                                           gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = vala_lint_checks_line_length_check_get_maximum_characters (self);
	if (old_value != value) {
		self->priv->_maximum_characters = value;
		g_object_notify_by_pspec ((GObject *) self, vala_lint_checks_line_length_check_properties[VALA_LINT_CHECKS_LINE_LENGTH_CHECK_MAXIMUM_CHARACTERS_PROPERTY]);
	}
}

gboolean
vala_lint_checks_line_length_check_get_ignore_comments (ValaLintChecksLineLengthCheck* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_ignore_comments;
	return result;
}

void
vala_lint_checks_line_length_check_set_ignore_comments (ValaLintChecksLineLengthCheck* self,
                                                        gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = vala_lint_checks_line_length_check_get_ignore_comments (self);
	if (old_value != value) {
		self->priv->_ignore_comments = value;
		g_object_notify_by_pspec ((GObject *) self, vala_lint_checks_line_length_check_properties[VALA_LINT_CHECKS_LINE_LENGTH_CHECK_IGNORE_COMMENTS_PROPERTY]);
	}
}

static void
vala_lint_checks_line_length_check_class_init (ValaLintChecksLineLengthCheckClass * klass,
                                               gpointer klass_data)
{
	vala_lint_checks_line_length_check_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ValaLintChecksLineLengthCheck_private_offset);
	((ValaLintCheckClass *) klass)->check = (void (*) (ValaLintCheck*, ValaArrayList*, ValaArrayList**)) vala_lint_checks_line_length_check_real_check;
	G_OBJECT_CLASS (klass)->get_property = _vala_vala_lint_checks_line_length_check_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_vala_lint_checks_line_length_check_set_property;
	G_OBJECT_CLASS (klass)->finalize = vala_lint_checks_line_length_check_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALA_LINT_CHECKS_LINE_LENGTH_CHECK_MAXIMUM_CHARACTERS_PROPERTY, vala_lint_checks_line_length_check_properties[VALA_LINT_CHECKS_LINE_LENGTH_CHECK_MAXIMUM_CHARACTERS_PROPERTY] = g_param_spec_int ("maximum-characters", "maximum-characters", "maximum-characters", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALA_LINT_CHECKS_LINE_LENGTH_CHECK_IGNORE_COMMENTS_PROPERTY, vala_lint_checks_line_length_check_properties[VALA_LINT_CHECKS_LINE_LENGTH_CHECK_IGNORE_COMMENTS_PROPERTY] = g_param_spec_boolean ("ignore-comments", "ignore-comments", "ignore-comments", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
vala_lint_checks_line_length_check_instance_init (ValaLintChecksLineLengthCheck * self,
                                                  gpointer klass)
{
	self->priv = vala_lint_checks_line_length_check_get_instance_private (self);
}

static void
vala_lint_checks_line_length_check_finalize (GObject * obj)
{
	ValaLintChecksLineLengthCheck * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_LINT_CHECKS_TYPE_LINE_LENGTH_CHECK, ValaLintChecksLineLengthCheck);
	G_OBJECT_CLASS (vala_lint_checks_line_length_check_parent_class)->finalize (obj);
}

static GType
vala_lint_checks_line_length_check_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ValaLintChecksLineLengthCheckClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_lint_checks_line_length_check_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaLintChecksLineLengthCheck), 0, (GInstanceInitFunc) vala_lint_checks_line_length_check_instance_init, NULL };
	GType vala_lint_checks_line_length_check_type_id;
	vala_lint_checks_line_length_check_type_id = g_type_register_static (VALA_LINT_TYPE_CHECK, "ValaLintChecksLineLengthCheck", &g_define_type_info, 0);
	ValaLintChecksLineLengthCheck_private_offset = g_type_add_instance_private (vala_lint_checks_line_length_check_type_id, sizeof (ValaLintChecksLineLengthCheckPrivate));
	return vala_lint_checks_line_length_check_type_id;
}

GType
vala_lint_checks_line_length_check_get_type (void)
{
	static volatile gsize vala_lint_checks_line_length_check_type_id__once = 0;
	if (g_once_init_enter (&vala_lint_checks_line_length_check_type_id__once)) {
		GType vala_lint_checks_line_length_check_type_id;
		vala_lint_checks_line_length_check_type_id = vala_lint_checks_line_length_check_get_type_once ();
		g_once_init_leave (&vala_lint_checks_line_length_check_type_id__once, vala_lint_checks_line_length_check_type_id);
	}
	return vala_lint_checks_line_length_check_type_id__once;
}

static void
_vala_vala_lint_checks_line_length_check_get_property (GObject * object,
                                                       guint property_id,
                                                       GValue * value,
                                                       GParamSpec * pspec)
{
	ValaLintChecksLineLengthCheck * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VALA_LINT_CHECKS_TYPE_LINE_LENGTH_CHECK, ValaLintChecksLineLengthCheck);
	switch (property_id) {
		case VALA_LINT_CHECKS_LINE_LENGTH_CHECK_MAXIMUM_CHARACTERS_PROPERTY:
		g_value_set_int (value, vala_lint_checks_line_length_check_get_maximum_characters (self));
		break;
		case VALA_LINT_CHECKS_LINE_LENGTH_CHECK_IGNORE_COMMENTS_PROPERTY:
		g_value_set_boolean (value, vala_lint_checks_line_length_check_get_ignore_comments (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_vala_lint_checks_line_length_check_set_property (GObject * object,
                                                       guint property_id,
                                                       const GValue * value,
                                                       GParamSpec * pspec)
{
	ValaLintChecksLineLengthCheck * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VALA_LINT_CHECKS_TYPE_LINE_LENGTH_CHECK, ValaLintChecksLineLengthCheck);
	switch (property_id) {
		case VALA_LINT_CHECKS_LINE_LENGTH_CHECK_MAXIMUM_CHARACTERS_PROPERTY:
		vala_lint_checks_line_length_check_set_maximum_characters (self, g_value_get_int (value));
		break;
		case VALA_LINT_CHECKS_LINE_LENGTH_CHECK_IGNORE_COMMENTS_PROPERTY:
		vala_lint_checks_line_length_check_set_ignore_comments (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

