/* TrailingNewlinesCheck.c generated by valac 0.56.3, the Vala compiler
 * generated from TrailingNewlinesCheck.vala, do not modify */

/*
 * Copyright (c) 2019 elementary LLC. (https://github.com/elementary/vala-lint)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */

#include "vala-linter.h"
#include <valagee.h>
#include <glib-object.h>
#include <vala.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>

enum  {
	VALA_LINT_CHECKS_TRAILING_NEWLINES_CHECK_0_PROPERTY,
	VALA_LINT_CHECKS_TRAILING_NEWLINES_CHECK_NUM_PROPERTIES
};
static GParamSpec* vala_lint_checks_trailing_newlines_check_properties[VALA_LINT_CHECKS_TRAILING_NEWLINES_CHECK_NUM_PROPERTIES];
#define _parse_result_free0(var) ((var == NULL) ? NULL : (var = (parse_result_free (var), NULL)))

static gpointer vala_lint_checks_trailing_newlines_check_parent_class = NULL;

static void vala_lint_checks_trailing_newlines_check_real_check (ValaLintCheck* base,
                                                          ValaArrayList* parse_result,
                                                          ValaArrayList** mistake_list);
static gboolean vala_lint_checks_trailing_newlines_check_real_apply_fix (ValaLintCheck* base,
                                                                  ValaSourceLocation* begin,
                                                                  ValaSourceLocation* end,
                                                                  gchar** contents);
static GType vala_lint_checks_trailing_newlines_check_get_type_once (void);

ValaLintChecksTrailingNewlinesCheck*
vala_lint_checks_trailing_newlines_check_construct (GType object_type)
{
	ValaLintChecksTrailingNewlinesCheck * self = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	self = (ValaLintChecksTrailingNewlinesCheck*) g_object_new (object_type, "title", "trailing-newlines", "description", _ ("Checks for a single newline at the end of files"), NULL);
	_tmp0_ = vala_lint_check_get_title ((ValaLintCheck*) self);
	_tmp1_ = _tmp0_;
	vala_lint_check_set_state ((ValaLintCheck*) self, vala_lint_config_get_state (_tmp1_));
	return self;
}

ValaLintChecksTrailingNewlinesCheck*
vala_lint_checks_trailing_newlines_check_new (void)
{
	return vala_lint_checks_trailing_newlines_check_construct (VALA_LINT_CHECKS_TYPE_TRAILING_NEWLINES_CHECK);
}

static void
vala_lint_checks_trailing_newlines_check_real_check (ValaLintCheck* base,
                                                     ValaArrayList* parse_result,
                                                     ValaArrayList** mistake_list)
{
	ValaLintChecksTrailingNewlinesCheck * self;
	ParseResult r_last = {0};
	gpointer _tmp0_;
	ParseResult* _tmp1_;
	ParseResult _tmp2_;
	ParseResult _tmp3_ = {0};
	ParseResult _tmp4_;
	ParseResult _tmp5_;
	self = (ValaLintChecksTrailingNewlinesCheck*) base;
	g_return_if_fail (parse_result != NULL);
	g_return_if_fail (*mistake_list != NULL);
	_tmp0_ = vala_list_last ((ValaList*) parse_result);
	_tmp1_ = (ParseResult*) _tmp0_;
	_tmp2_ = *_tmp1_;
	parse_result_copy (&_tmp2_, &_tmp3_);
	_tmp4_ = _tmp3_;
	_parse_result_free0 (_tmp1_);
	r_last = _tmp4_;
	_tmp5_ = r_last;
	if (_tmp5_.type == PARSE_TYPE_DEFAULT) {
		ParseResult _tmp6_;
		ParseResult _tmp7_;
		_tmp6_ = r_last;
		vala_lint_check_add_regex_mistake ((ValaLintCheck*) self, "[^\\n]\\z", _ ("Missing newline at the end of file"), &_tmp6_, mistake_list, 1, 0, FALSE);
		_tmp7_ = r_last;
		vala_lint_check_add_regex_mistake ((ValaLintCheck*) self, "\\n{2,}\\z", _ ("Multiple newlines at the end of file"), &_tmp7_, mistake_list, 1, 0, FALSE);
	}
	parse_result_destroy (&r_last);
}

static gboolean
vala_lint_checks_trailing_newlines_check_real_apply_fix (ValaLintCheck* base,
                                                         ValaSourceLocation* begin,
                                                         ValaSourceLocation* end,
                                                         gchar** contents)
{
	ValaLintChecksTrailingNewlinesCheck * self;
	gboolean result;
	self = (ValaLintChecksTrailingNewlinesCheck*) base;
	g_return_val_if_fail (begin != NULL, FALSE);
	g_return_val_if_fail (end != NULL, FALSE);
	g_return_val_if_fail (*contents != NULL, FALSE);
	g_strchomp (*contents);
	result = TRUE;
	return result;
}

static void
vala_lint_checks_trailing_newlines_check_class_init (ValaLintChecksTrailingNewlinesCheckClass * klass,
                                                     gpointer klass_data)
{
	vala_lint_checks_trailing_newlines_check_parent_class = g_type_class_peek_parent (klass);
	((ValaLintCheckClass *) klass)->check = (void (*) (ValaLintCheck*, ValaArrayList*, ValaArrayList**)) vala_lint_checks_trailing_newlines_check_real_check;
	((ValaLintCheckClass *) klass)->apply_fix = (gboolean (*) (ValaLintCheck*, ValaSourceLocation*, ValaSourceLocation*, gchar**)) vala_lint_checks_trailing_newlines_check_real_apply_fix;
}

static void
vala_lint_checks_trailing_newlines_check_instance_init (ValaLintChecksTrailingNewlinesCheck * self,
                                                        gpointer klass)
{
}

static GType
vala_lint_checks_trailing_newlines_check_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ValaLintChecksTrailingNewlinesCheckClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_lint_checks_trailing_newlines_check_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaLintChecksTrailingNewlinesCheck), 0, (GInstanceInitFunc) vala_lint_checks_trailing_newlines_check_instance_init, NULL };
	GType vala_lint_checks_trailing_newlines_check_type_id;
	vala_lint_checks_trailing_newlines_check_type_id = g_type_register_static (VALA_LINT_TYPE_CHECK, "ValaLintChecksTrailingNewlinesCheck", &g_define_type_info, 0);
	return vala_lint_checks_trailing_newlines_check_type_id;
}

GType
vala_lint_checks_trailing_newlines_check_get_type (void)
{
	static volatile gsize vala_lint_checks_trailing_newlines_check_type_id__once = 0;
	if (g_once_init_enter (&vala_lint_checks_trailing_newlines_check_type_id__once)) {
		GType vala_lint_checks_trailing_newlines_check_type_id;
		vala_lint_checks_trailing_newlines_check_type_id = vala_lint_checks_trailing_newlines_check_get_type_once ();
		g_once_init_leave (&vala_lint_checks_trailing_newlines_check_type_id__once, vala_lint_checks_trailing_newlines_check_type_id);
	}
	return vala_lint_checks_trailing_newlines_check_type_id__once;
}

