/* Disabler.c generated by valac 0.56.3, the Vala compiler
 * generated from Disabler.vala, do not modify */

/*
 * Copyright (c) 2019 elementary LLC. (https://github.com/elementary/vala-lint)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */

#include "vala-linter.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <vala.h>
#include <valagee.h>
#include <glib-object.h>

#define VALA_LINT_DISABLER_DISABLE_KEY "vala-lint="
#define VALA_LINT_DISABLER_SKIP_FILE_KEY "skip-file"

#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	VALA_LINT_DISABLER_0_PROPERTY,
	VALA_LINT_DISABLER_NUM_PROPERTIES
};
static GParamSpec* vala_lint_disabler_properties[VALA_LINT_DISABLER_NUM_PROPERTIES];
#define _parse_result_free0(var) ((var == NULL) ? NULL : (var = (parse_result_free (var), NULL)))
#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_lint_disable_result_free0(var) ((var == NULL) ? NULL : (var = (vala_lint_disable_result_free (var), NULL)))

struct _Block1Data {
	int _ref_count_;
	ValaLintDisabler* self;
	ValaArrayList* disable_results;
};

static gpointer vala_lint_disabler_parent_class = NULL;

static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean __lambda4_ (Block1Data* _data1_,
                     ValaLintFormatMistake* m);
static gboolean ___lambda4__vala_lint_utils_filter_function (gconstpointer element,
                                                      gpointer self);
static GType vala_lint_disabler_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

void
vala_lint_disable_result_copy (const ValaLintDisableResult* self,
                               ValaLintDisableResult* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	ValaSourceLocation _tmp2_;
	_tmp0_ = (*self).check_title;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).check_title);
	(*dest).check_title = _tmp1_;
	_tmp2_ = (*self).location;
	(*dest).location = _tmp2_;
}

void
vala_lint_disable_result_destroy (ValaLintDisableResult* self)
{
	_g_free0 ((*self).check_title);
}

ValaLintDisableResult*
vala_lint_disable_result_dup (const ValaLintDisableResult* self)
{
	ValaLintDisableResult* dup;
	dup = g_new0 (ValaLintDisableResult, 1);
	vala_lint_disable_result_copy (self, dup);
	return dup;
}

void
vala_lint_disable_result_free (ValaLintDisableResult* self)
{
	vala_lint_disable_result_destroy (self);
	g_free (self);
}

static GType
vala_lint_disable_result_get_type_once (void)
{
	GType vala_lint_disable_result_type_id;
	vala_lint_disable_result_type_id = g_boxed_type_register_static ("ValaLintDisableResult", (GBoxedCopyFunc) vala_lint_disable_result_dup, (GBoxedFreeFunc) vala_lint_disable_result_free);
	return vala_lint_disable_result_type_id;
}

GType
vala_lint_disable_result_get_type (void)
{
	static volatile gsize vala_lint_disable_result_type_id__once = 0;
	if (g_once_init_enter (&vala_lint_disable_result_type_id__once)) {
		GType vala_lint_disable_result_type_id;
		vala_lint_disable_result_type_id = vala_lint_disable_result_get_type_once ();
		g_once_init_leave (&vala_lint_disable_result_type_id__once, vala_lint_disable_result_type_id);
	}
	return vala_lint_disable_result_type_id__once;
}

/**
     * Parses a list of checks to disable at specific lines.
     *
     * @param parse_result The parse result from ValaLint.Parser.
     */
static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (needle != NULL, 0);
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	if (_tmp1_ != NULL) {
		gchar* _tmp2_;
		_tmp2_ = _result_;
		result = (gint) (_tmp2_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	if (start < ((glong) 0)) {
		start = string_length + start;
	}
	if (end < ((glong) 0)) {
		end = string_length + end;
	}
	if (start >= ((glong) 0)) {
		_tmp2_ = start <= string_length;
	} else {
		_tmp2_ = FALSE;
	}
	g_return_val_if_fail (_tmp2_, NULL);
	if (end >= ((glong) 0)) {
		_tmp3_ = end <= string_length;
	} else {
		_tmp3_ = FALSE;
	}
	g_return_val_if_fail (_tmp3_, NULL);
	g_return_val_if_fail (start <= end, NULL);
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
	result = _tmp4_;
	return result;
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strstrip (_result_);
	result = _result_;
	return result;
}

ValaArrayList*
vala_lint_disabler_parse (ValaLintDisabler* self,
                          ValaArrayList* parse_result)
{
	ValaArrayList* _result_ = NULL;
	GEqualFunc _tmp0_;
	ValaArrayList* _tmp1_;
	ValaArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (parse_result != NULL, NULL);
	_tmp0_ = g_direct_equal;
	_tmp1_ = vala_array_list_new (VALA_LINT_TYPE_DISABLE_RESULT, (GBoxedCopyFunc) vala_lint_disable_result_dup, (GDestroyNotify) vala_lint_disable_result_free, _tmp0_);
	_result_ = _tmp1_;
	{
		ValaArrayList* _r_list = NULL;
		gint _r_size = 0;
		ValaArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _r_index = 0;
		_r_list = parse_result;
		_tmp2_ = _r_list;
		_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_r_size = _tmp4_;
		_r_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			ParseResult r = {0};
			ValaArrayList* _tmp7_;
			gpointer _tmp8_;
			ParseResult* _tmp9_;
			ParseResult _tmp10_;
			ParseResult _tmp11_ = {0};
			ParseResult _tmp12_;
			ParseResult _tmp13_;
			_r_index = _r_index + 1;
			_tmp5_ = _r_index;
			_tmp6_ = _r_size;
			if (!(_tmp5_ < _tmp6_)) {
				break;
			}
			_tmp7_ = _r_list;
			_tmp8_ = vala_list_get ((ValaList*) _tmp7_, _r_index);
			_tmp9_ = (ParseResult*) _tmp8_;
			_tmp10_ = *_tmp9_;
			parse_result_copy (&_tmp10_, &_tmp11_);
			_tmp12_ = _tmp11_;
			_parse_result_free0 (_tmp9_);
			r = _tmp12_;
			_tmp13_ = r;
			if (_tmp13_.detail_type == PARSE_DETAIL_TYPE_INLINE_COMMENT) {
				gint index = 0;
				ParseResult _tmp14_;
				const gchar* _tmp15_;
				_tmp14_ = r;
				_tmp15_ = _tmp14_.text;
				index = string_index_of (_tmp15_, VALA_LINT_DISABLER_DISABLE_KEY, 0);
				if (index > 0) {
					gint _tmp16_;
					gint _tmp17_;
					gchar** title_list = NULL;
					ParseResult _tmp18_;
					const gchar* _tmp19_;
					ParseResult _tmp20_;
					const gchar* _tmp21_;
					gint _tmp22_;
					gint _tmp23_;
					gchar* _tmp24_;
					gchar* _tmp25_;
					gchar** _tmp26_;
					gchar** _tmp27_;
					gchar** _tmp28_;
					gint _tmp28__length1;
					gint title_list_length1;
					gint _title_list_size_;
					gchar** _tmp29_;
					gint _tmp29__length1;
					_tmp16_ = strlen (VALA_LINT_DISABLER_DISABLE_KEY);
					_tmp17_ = _tmp16_;
					index += _tmp17_;
					_tmp18_ = r;
					_tmp19_ = _tmp18_.text;
					_tmp20_ = r;
					_tmp21_ = _tmp20_.text;
					_tmp22_ = strlen (_tmp21_);
					_tmp23_ = _tmp22_;
					_tmp24_ = string_slice (_tmp19_, (glong) index, (glong) _tmp23_);
					_tmp25_ = _tmp24_;
					_tmp27_ = _tmp26_ = g_strsplit (_tmp25_, ",", 0);
					_tmp28_ = _tmp27_;
					_tmp28__length1 = _vala_array_length (_tmp26_);
					_g_free0 (_tmp25_);
					title_list = _tmp28_;
					title_list_length1 = _tmp28__length1;
					_title_list_size_ = title_list_length1;
					_tmp29_ = title_list;
					_tmp29__length1 = title_list_length1;
					{
						gchar** title_collection = NULL;
						gint title_collection_length1 = 0;
						gint _title_collection_size_ = 0;
						gint title_it = 0;
						title_collection = _tmp29_;
						title_collection_length1 = _tmp29__length1;
						for (title_it = 0; title_it < title_collection_length1; title_it = title_it + 1) {
							gchar* _tmp30_;
							gchar* title = NULL;
							_tmp30_ = g_strdup (title_collection[title_it]);
							title = _tmp30_;
							{
								ValaArrayList* _tmp31_;
								const gchar* _tmp32_;
								gchar* _tmp33_;
								gchar* _tmp34_;
								ParseResult _tmp35_;
								ValaSourceLocation _tmp36_;
								ValaLintDisableResult _tmp37_ = {0};
								_tmp31_ = _result_;
								_tmp32_ = title;
								_tmp33_ = string_strip (_tmp32_);
								_tmp34_ = _tmp33_;
								_tmp35_ = r;
								_tmp36_ = _tmp35_.begin;
								_g_free0 (_tmp37_.check_title);
								_tmp37_.check_title = _tmp34_;
								_tmp37_.location = _tmp36_;
								vala_collection_add ((ValaCollection*) _tmp31_, &_tmp37_);
								_g_free0 (_tmp34_);
								_g_free0 (title);
							}
						}
					}
					title_list = (_vala_array_free (title_list, title_list_length1, (GDestroyNotify) g_free), NULL);
				}
			}
			parse_result_destroy (&r);
		}
	}
	result = _result_;
	return result;
}

/**
     * Filters a list of mistakes given checks to disable at specific lines.
     *
     * @param mistakes The overall mistake list from the Linter.
     * @param disable_results The list of results to disable.
     */
static gpointer
_vala_iterable_ref0 (gpointer self)
{
	return self ? vala_iterable_ref (self) : NULL;
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		ValaLintDisabler* self;
		self = _data1_->self;
		_vala_iterable_unref0 (_data1_->disable_results);
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}

static gboolean
__lambda4_ (Block1Data* _data1_,
            ValaLintFormatMistake* m)
{
	ValaLintDisabler* self;
	gboolean result;
	self = _data1_->self;
	{
		ValaArrayList* _r_list = NULL;
		gint _r_size = 0;
		ValaArrayList* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		gint _r_index = 0;
		_r_list = _data1_->disable_results;
		_tmp0_ = _r_list;
		_tmp1_ = vala_collection_get_size ((ValaCollection*) _tmp0_);
		_tmp2_ = _tmp1_;
		_r_size = _tmp2_;
		_r_index = -1;
		while (TRUE) {
			gint _tmp3_;
			gint _tmp4_;
			ValaLintDisableResult r = {0};
			ValaArrayList* _tmp5_;
			gpointer _tmp6_;
			ValaLintDisableResult* _tmp7_;
			ValaLintDisableResult _tmp8_;
			ValaLintDisableResult _tmp9_ = {0};
			ValaLintDisableResult _tmp10_;
			gboolean _tmp11_ = FALSE;
			ValaLintCheck* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			ValaLintDisableResult _tmp15_;
			const gchar* _tmp16_;
			_r_index = _r_index + 1;
			_tmp3_ = _r_index;
			_tmp4_ = _r_size;
			if (!(_tmp3_ < _tmp4_)) {
				break;
			}
			_tmp5_ = _r_list;
			_tmp6_ = vala_list_get ((ValaList*) _tmp5_, _r_index);
			_tmp7_ = (ValaLintDisableResult*) _tmp6_;
			_tmp8_ = *_tmp7_;
			vala_lint_disable_result_copy (&_tmp8_, &_tmp9_);
			_tmp10_ = _tmp9_;
			_vala_lint_disable_result_free0 (_tmp7_);
			r = _tmp10_;
			_tmp12_ = (*m).check;
			_tmp13_ = vala_lint_check_get_title (_tmp12_);
			_tmp14_ = _tmp13_;
			_tmp15_ = r;
			_tmp16_ = _tmp15_.check_title;
			if (g_strcmp0 (_tmp14_, _tmp16_) == 0) {
				ValaSourceLocation _tmp17_;
				ValaLintDisableResult _tmp18_;
				ValaSourceLocation _tmp19_;
				_tmp17_ = (*m).begin;
				_tmp18_ = r;
				_tmp19_ = _tmp18_.location;
				_tmp11_ = _tmp17_.line == _tmp19_.line;
			} else {
				_tmp11_ = FALSE;
			}
			if (_tmp11_) {
				result = FALSE;
				vala_lint_disable_result_destroy (&r);
				return result;
			}
			vala_lint_disable_result_destroy (&r);
		}
	}
	result = TRUE;
	return result;
}

static gboolean
___lambda4__vala_lint_utils_filter_function (gconstpointer element,
                                             gpointer self)
{
	gboolean result;
	result = __lambda4_ (self, (ValaLintFormatMistake*) element);
	return result;
}

ValaArrayList*
vala_lint_disabler_filter_mistakes (ValaLintDisabler* self,
                                    ValaArrayList* mistakes,
                                    ValaArrayList* disable_results)
{
	Block1Data* _data1_;
	ValaArrayList* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	ValaArrayList* _tmp9_;
	ValaArrayList* _tmp10_;
	ValaArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (mistakes != NULL, NULL);
	g_return_val_if_fail (disable_results != NULL, NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	_tmp0_ = _vala_iterable_ref0 (disable_results);
	_vala_iterable_unref0 (_data1_->disable_results);
	_data1_->disable_results = _tmp0_;
	_tmp2_ = vala_collection_get_is_empty ((ValaCollection*) _data1_->disable_results);
	_tmp3_ = _tmp2_;
	if (!_tmp3_) {
		gpointer _tmp4_;
		ValaLintDisableResult* _tmp5_;
		const gchar* _tmp6_;
		_tmp4_ = vala_list_first ((ValaList*) _data1_->disable_results);
		_tmp5_ = (ValaLintDisableResult*) _tmp4_;
		_tmp6_ = (*_tmp5_).check_title;
		_tmp1_ = g_strcmp0 (_tmp6_, VALA_LINT_DISABLER_SKIP_FILE_KEY) == 0;
		_vala_lint_disable_result_free0 (_tmp5_);
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		GEqualFunc _tmp7_;
		ValaArrayList* _tmp8_;
		_tmp7_ = g_direct_equal;
		_tmp8_ = vala_array_list_new (VALA_LINT_TYPE_FORMAT_MISTAKE, (GBoxedCopyFunc) vala_lint_format_mistake_dup, (GDestroyNotify) vala_lint_format_mistake_free, _tmp7_);
		result = _tmp8_;
		block1_data_unref (_data1_);
		_data1_ = NULL;
		return result;
	}
	_tmp9_ = mistakes;
	_tmp10_ = vala_lint_utils_filter (VALA_LINT_TYPE_FORMAT_MISTAKE, (GBoxedCopyFunc) vala_lint_format_mistake_dup, (GDestroyNotify) vala_lint_format_mistake_free, ___lambda4__vala_lint_utils_filter_function, _data1_, _tmp9_);
	result = _tmp10_;
	block1_data_unref (_data1_);
	_data1_ = NULL;
	return result;
}

ValaLintDisabler*
vala_lint_disabler_construct (GType object_type)
{
	ValaLintDisabler * self = NULL;
	self = (ValaLintDisabler*) g_object_new (object_type, NULL);
	return self;
}

ValaLintDisabler*
vala_lint_disabler_new (void)
{
	return vala_lint_disabler_construct (VALA_LINT_TYPE_DISABLER);
}

static void
vala_lint_disabler_class_init (ValaLintDisablerClass * klass,
                               gpointer klass_data)
{
	vala_lint_disabler_parent_class = g_type_class_peek_parent (klass);
}

static void
vala_lint_disabler_instance_init (ValaLintDisabler * self,
                                  gpointer klass)
{
}

static GType
vala_lint_disabler_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ValaLintDisablerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_lint_disabler_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaLintDisabler), 0, (GInstanceInitFunc) vala_lint_disabler_instance_init, NULL };
	GType vala_lint_disabler_type_id;
	vala_lint_disabler_type_id = g_type_register_static (G_TYPE_OBJECT, "ValaLintDisabler", &g_define_type_info, 0);
	return vala_lint_disabler_type_id;
}

GType
vala_lint_disabler_get_type (void)
{
	static volatile gsize vala_lint_disabler_type_id__once = 0;
	if (g_once_init_enter (&vala_lint_disabler_type_id__once)) {
		GType vala_lint_disabler_type_id;
		vala_lint_disabler_type_id = vala_lint_disabler_get_type_once ();
		g_once_init_leave (&vala_lint_disabler_type_id__once, vala_lint_disabler_type_id);
	}
	return vala_lint_disabler_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

