/* Fixer.c generated by valac 0.56.3, the Vala compiler
 * generated from Fixer.vala, do not modify */

/*
 * Copyright (c) 2016-2021 elementary LLC. (https://github.com/vala-lang/vala-lint)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Darshak Parikh <darshak@protonmail.com>
 */

#include "vala-linter.h"
#include <gio/gio.h>
#include <valagee.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>
#include <vala.h>

enum  {
	VALA_LINT_FIXER_0_PROPERTY,
	VALA_LINT_FIXER_NUM_PROPERTIES
};
static GParamSpec* vala_lint_fixer_properties[VALA_LINT_FIXER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_lint_format_mistake_free0(var) ((var == NULL) ? NULL : (var = (vala_lint_format_mistake_free (var), NULL)))
#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))

static gpointer vala_lint_fixer_parent_class = NULL;

static gboolean __lambda5_ (ValaLintFormatMistake* a,
                     ValaLintFormatMistake* b);
static gboolean ___lambda5__gequal_func (gconstpointer a,
                                  gconstpointer b);
static gint __lambda6_ (ValaLintFixer* self,
                 ValaLintFormatMistake* a,
                 ValaLintFormatMistake* b);
static gint ___lambda6__gcompare_data_func (gconstpointer a,
                                     gconstpointer b,
                                     gpointer self);
static GType vala_lint_fixer_get_type_once (void);

static gboolean
__lambda5_ (ValaLintFormatMistake* a,
            ValaLintFormatMistake* b)
{
	ValaLintFormatMistake _tmp0_;
	gboolean result;
	_tmp0_ = *b;
	result = vala_lint_format_mistake_equal_to (a, &_tmp0_);
	return result;
}

static gboolean
___lambda5__gequal_func (gconstpointer a,
                         gconstpointer b)
{
	gboolean result;
	result = __lambda5_ ((ValaLintFormatMistake*) a, (ValaLintFormatMistake*) b);
	return result;
}

static gpointer
_vala_iterable_ref0 (gpointer self)
{
	return self ? vala_iterable_ref (self) : NULL;
}

static gint
__lambda6_ (ValaLintFixer* self,
            ValaLintFormatMistake* a,
            ValaLintFormatMistake* b)
{
	ValaSourceLocation _tmp0_;
	ValaSourceLocation _tmp1_;
	ValaSourceLocation _tmp4_;
	ValaSourceLocation _tmp5_;
	gint result;
	_tmp0_ = (*a).begin;
	_tmp1_ = (*b).begin;
	if (_tmp0_.line == _tmp1_.line) {
		ValaSourceLocation _tmp2_;
		ValaSourceLocation _tmp3_;
		_tmp2_ = (*a).begin;
		_tmp3_ = (*b).begin;
		result = _tmp2_.column - _tmp3_.column;
		return result;
	}
	_tmp4_ = (*a).begin;
	_tmp5_ = (*b).begin;
	result = _tmp4_.line - _tmp5_.line;
	return result;
}

static gint
___lambda6__gcompare_data_func (gconstpointer a,
                                gconstpointer b,
                                gpointer self)
{
	gint result;
	result = __lambda6_ ((ValaLintFixer*) self, (ValaLintFormatMistake*) a, (ValaLintFormatMistake*) b);
	return result;
}

void
vala_lint_fixer_apply_fixes_for_file (ValaLintFixer* self,
                                      GFile* file,
                                      ValaArrayList** mistakes,
                                      GError** error)
{
	gchar* filename = NULL;
	gchar* _tmp0_;
	gchar* contents = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	ValaArrayList* remaining_mistakes = NULL;
	ValaArrayList* _tmp3_;
	ValaArrayList* _tmp18_;
	ValaArrayList* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	g_return_if_fail (*mistakes != NULL);
	_tmp0_ = g_file_get_path (file);
	filename = _tmp0_;
	_tmp1_ = filename;
	g_file_get_contents (_tmp1_, &_tmp2_, NULL, &_inner_error0_);
	_g_free0 (contents);
	contents = _tmp2_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_free0 (contents);
		_g_free0 (filename);
		return;
	}
	_tmp3_ = vala_array_list_new (VALA_LINT_TYPE_FORMAT_MISTAKE, (GBoxedCopyFunc) vala_lint_format_mistake_dup, (GDestroyNotify) vala_lint_format_mistake_free, ___lambda5__gequal_func);
	remaining_mistakes = _tmp3_;
	{
		gint index = 0;
		gint _tmp4_;
		gint _tmp5_;
		_tmp4_ = vala_collection_get_size ((ValaCollection*) (*mistakes));
		_tmp5_ = _tmp4_;
		index = _tmp5_ - 1;
		{
			gboolean _tmp6_ = FALSE;
			_tmp6_ = TRUE;
			while (TRUE) {
				ValaLintFormatMistake* mistake = NULL;
				gpointer _tmp8_;
				gboolean applied = FALSE;
				ValaLintFormatMistake* _tmp9_;
				ValaLintCheck* _tmp10_;
				ValaLintFormatMistake* _tmp11_;
				ValaSourceLocation _tmp12_;
				ValaLintFormatMistake* _tmp13_;
				ValaSourceLocation _tmp14_;
				gboolean _tmp15_;
				if (!_tmp6_) {
					gint _tmp7_;
					_tmp7_ = index;
					index = _tmp7_ - 1;
				}
				_tmp6_ = FALSE;
				if (!(index >= 0)) {
					break;
				}
				_tmp8_ = vala_list_get ((ValaList*) (*mistakes), index);
				mistake = (ValaLintFormatMistake*) _tmp8_;
				_tmp9_ = mistake;
				_tmp10_ = (*_tmp9_).check;
				_tmp11_ = mistake;
				_tmp12_ = (*_tmp11_).begin;
				_tmp13_ = mistake;
				_tmp14_ = (*_tmp13_).end;
				_tmp15_ = vala_lint_check_apply_fix (_tmp10_, &_tmp12_, &_tmp14_, &contents);
				applied = _tmp15_;
				if (!applied) {
					ValaArrayList* _tmp16_;
					ValaLintFormatMistake* _tmp17_;
					_tmp16_ = remaining_mistakes;
					_tmp17_ = mistake;
					vala_collection_add ((ValaCollection*) _tmp16_, _tmp17_);
				}
				_vala_lint_format_mistake_free0 (mistake);
			}
		}
	}
	_tmp18_ = remaining_mistakes;
	_tmp19_ = _vala_iterable_ref0 (_tmp18_);
	_vala_iterable_unref0 (*mistakes);
	*mistakes = _tmp19_;
	vala_list_sort ((ValaList*) (*mistakes), ___lambda6__gcompare_data_func, g_object_ref (self), g_object_unref);
	_tmp20_ = filename;
	_tmp21_ = contents;
	g_file_set_contents (_tmp20_, _tmp21_, (gssize) -1, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_vala_iterable_unref0 (remaining_mistakes);
		_g_free0 (contents);
		_g_free0 (filename);
		return;
	}
	_vala_iterable_unref0 (remaining_mistakes);
	_g_free0 (contents);
	_g_free0 (filename);
}

ValaLintFixer*
vala_lint_fixer_construct (GType object_type)
{
	ValaLintFixer * self = NULL;
	self = (ValaLintFixer*) g_object_new (object_type, NULL);
	return self;
}

ValaLintFixer*
vala_lint_fixer_new (void)
{
	return vala_lint_fixer_construct (VALA_LINT_TYPE_FIXER);
}

static void
vala_lint_fixer_class_init (ValaLintFixerClass * klass,
                            gpointer klass_data)
{
	vala_lint_fixer_parent_class = g_type_class_peek_parent (klass);
}

static void
vala_lint_fixer_instance_init (ValaLintFixer * self,
                               gpointer klass)
{
}

static GType
vala_lint_fixer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ValaLintFixerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_lint_fixer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaLintFixer), 0, (GInstanceInitFunc) vala_lint_fixer_instance_init, NULL };
	GType vala_lint_fixer_type_id;
	vala_lint_fixer_type_id = g_type_register_static (G_TYPE_OBJECT, "ValaLintFixer", &g_define_type_info, 0);
	return vala_lint_fixer_type_id;
}

GType
vala_lint_fixer_get_type (void)
{
	static volatile gsize vala_lint_fixer_type_id__once = 0;
	if (g_once_init_enter (&vala_lint_fixer_type_id__once)) {
		GType vala_lint_fixer_type_id;
		vala_lint_fixer_type_id = vala_lint_fixer_get_type_once ();
		g_once_init_leave (&vala_lint_fixer_type_id__once, vala_lint_fixer_type_id);
	}
	return vala_lint_fixer_type_id__once;
}

