/* Utils.c generated by valac 0.56.3, the Vala compiler
 * generated from Utils.vala, do not modify */

/*
 * Copyright (c) 2018-2019 elementary LLC. (https://github.com/elementary/Vala-Lint)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */

#include "vala-linter.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <vala.h>
#include <valagee.h>
#include <glib-object.h>

enum  {
	VALA_LINT_UTILS_0_PROPERTY,
	VALA_LINT_UTILS_NUM_PROPERTIES
};
static GParamSpec* vala_lint_utils_properties[VALA_LINT_UTILS_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

static gpointer vala_lint_utils_parent_class = NULL;

static GType vala_lint_utils_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

/**
     * Method to get the position within an input string. Similar to index_of, but for non-null terminated strings using char pointers.
     *
     * @return The position of first index, otherwise null.
     */
static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}

gchar*
vala_lint_utils_get_pos_of (const gchar* needle,
                            gchar* begin,
                            gchar* end)
{
	gchar* pos = NULL;
	gchar* result;
	g_return_val_if_fail (needle != NULL, NULL);
	pos = begin;
	while (TRUE) {
		gchar* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		gboolean equal = FALSE;
		gchar* _tmp10_;
		_tmp0_ = pos;
		_tmp1_ = strlen (needle);
		_tmp2_ = _tmp1_;
		if (!(_tmp0_ <= (end - _tmp2_))) {
			break;
		}
		equal = TRUE;
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp3_ = FALSE;
				_tmp3_ = TRUE;
				while (TRUE) {
					gint _tmp5_;
					gint _tmp6_;
					gchar* _tmp7_;
					gchar _tmp8_;
					if (!_tmp3_) {
						gint _tmp4_;
						_tmp4_ = i;
						i = _tmp4_ + 1;
					}
					_tmp3_ = FALSE;
					_tmp5_ = strlen (needle);
					_tmp6_ = _tmp5_;
					if (!(i < _tmp6_)) {
						break;
					}
					_tmp7_ = pos;
					_tmp8_ = _tmp7_[i];
					if (_tmp8_ != string_get (needle, (glong) i)) {
						equal = FALSE;
						break;
					}
				}
			}
		}
		if (equal) {
			gchar* _tmp9_;
			_tmp9_ = pos;
			result = _tmp9_;
			return result;
		}
		_tmp10_ = pos;
		pos = _tmp10_ + 1;
	}
	result = NULL;
	return result;
}

/**
     * Method to get the line count of a string.
     *
     * @return The number of lines in the input string.
     */
gint
vala_lint_utils_get_line_count (const gchar* input)
{
	gchar** _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gint _tmp3_;
	gint result;
	g_return_val_if_fail (input != NULL, 0);
	_tmp1_ = _tmp0_ = g_strsplit (input, "\n", 0);
	_tmp2_ = _tmp1_;
	_tmp2__length1 = _vala_array_length (_tmp0_);
	_tmp3_ = MAX (_vala_array_length (_tmp0_) - 1, 0);
	_tmp2_ = (_vala_array_free (_tmp2_, _tmp2__length1, (GDestroyNotify) g_free), NULL);
	result = _tmp3_;
	return result;
}

/**
     * Method to get the char position in the current line of the input string.
     *
     * @return The char column.
     */
static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	if (start < ((glong) 0)) {
		start = string_length + start;
	}
	if (end < ((glong) 0)) {
		end = string_length + end;
	}
	if (start >= ((glong) 0)) {
		_tmp2_ = start <= string_length;
	} else {
		_tmp2_ = FALSE;
	}
	g_return_val_if_fail (_tmp2_, NULL);
	if (end >= ((glong) 0)) {
		_tmp3_ = end <= string_length;
	} else {
		_tmp3_ = FALSE;
	}
	g_return_val_if_fail (_tmp3_, NULL);
	g_return_val_if_fail (start <= end, NULL);
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
	result = _tmp4_;
	return result;
}

static gint
string_last_index_of_char (const gchar* self,
                           gunichar c,
                           gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = g_utf8_strrchr (((gchar*) self) + start_index, (gssize) -1, c);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	if (_tmp1_ != NULL) {
		gchar* _tmp2_;
		_tmp2_ = _result_;
		result = (gint) (_tmp2_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}

gint
vala_lint_utils_get_column_in_line (const gchar* input,
                                    gint pos)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp2_;
	gint result;
	g_return_val_if_fail (input != NULL, 0);
	_tmp0_ = string_slice (input, (glong) 0, (glong) pos);
	_tmp1_ = _tmp0_;
	_tmp2_ = (pos - string_last_index_of_char (_tmp1_, (gunichar) '\n', 0)) - 1;
	_g_free0 (_tmp1_);
	result = _tmp2_;
	return result;
}

/**
     * Method to get the char position in the current line of the input string using char pointers.
     *
     * @return The char column.
     */
gint
vala_lint_utils_get_column_of (gchar* begin,
                               gchar* pos)
{
	gint i = 0;
	gint result;
	i = 0;
	while (TRUE) {
		gboolean _tmp0_ = FALSE;
		gchar _tmp1_;
		_tmp1_ = (pos - i)[-1];
		if (_tmp1_ != '\n') {
			_tmp0_ = (pos - i) > begin;
		} else {
			_tmp0_ = FALSE;
		}
		if (!_tmp0_) {
			break;
		}
		i += 1;
	}
	result = i + 1;
	return result;
}

/**
     * Method to calculate an absolute location given a reference location and an offset column.
     * 
     * @return The absolute location.
     */
void
vala_lint_utils_get_absolute_location (ValaSourceLocation* reference,
                                       const gchar* text,
                                       gint offset,
                                       ValaSourceLocation* result)
{
	gint _tmp0_;
	gint _tmp1_;
	gint line_count = 0;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint _tmp4_;
	gint line = 0;
	ValaSourceLocation _tmp5_;
	gint column = 0;
	ValaSourceLocation _tmp7_;
	gchar* _tmp8_;
	ValaSourceLocation _tmp9_ = {0};
	g_return_if_fail (reference != NULL);
	g_return_if_fail (text != NULL);
	_tmp0_ = strlen (text);
	_tmp1_ = _tmp0_;
	offset = MIN (offset, _tmp1_);
	_tmp2_ = string_slice (text, (glong) 0, (glong) offset);
	_tmp3_ = _tmp2_;
	_tmp4_ = vala_lint_utils_get_line_count (_tmp3_);
	_g_free0 (_tmp3_);
	line_count = _tmp4_;
	_tmp5_ = *reference;
	line = _tmp5_.line + line_count;
	column = vala_lint_utils_get_column_in_line (text, offset);
	if (line_count == 0) {
		ValaSourceLocation _tmp6_;
		_tmp6_ = *reference;
		column += _tmp6_.column;
	}
	_tmp7_ = *reference;
	_tmp8_ = _tmp7_.pos;
	vala_source_location_init (&_tmp9_, _tmp8_ + offset, line, column);
	*result = _tmp9_;
	return;
}

ValaArrayList*
vala_lint_utils_filter (GType g_type,
                        GBoxedCopyFunc g_dup_func,
                        GDestroyNotify g_destroy_func,
                        ValaLintUtilsFilterFunction func,
                        gpointer func_target,
                        ValaArrayList* source)
{
	ValaArrayList* _result_ = NULL;
	GEqualFunc _tmp0_;
	ValaArrayList* _tmp1_;
	ValaArrayList* result;
	g_return_val_if_fail (source != NULL, NULL);
	_tmp0_ = g_direct_equal;
	_tmp1_ = vala_array_list_new (g_type, (GBoxedCopyFunc) g_dup_func, (GDestroyNotify) g_destroy_func, _tmp0_);
	_result_ = _tmp1_;
	{
		ValaArrayList* _elem_list = NULL;
		gint _elem_size = 0;
		ValaArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _elem_index = 0;
		_elem_list = source;
		_tmp2_ = _elem_list;
		_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_elem_size = _tmp4_;
		_elem_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			gpointer elem = NULL;
			ValaArrayList* _tmp7_;
			gpointer _tmp8_;
			gconstpointer _tmp9_;
			_elem_index = _elem_index + 1;
			_tmp5_ = _elem_index;
			_tmp6_ = _elem_size;
			if (!(_tmp5_ < _tmp6_)) {
				break;
			}
			_tmp7_ = _elem_list;
			_tmp8_ = vala_list_get ((ValaList*) _tmp7_, _elem_index);
			elem = _tmp8_;
			_tmp9_ = elem;
			if (func (_tmp9_, func_target)) {
				ValaArrayList* _tmp10_;
				gconstpointer _tmp11_;
				_tmp10_ = _result_;
				_tmp11_ = elem;
				vala_collection_add ((ValaCollection*) _tmp10_, _tmp11_);
			}
			((elem == NULL) || (g_destroy_func == NULL)) ? NULL : (elem = (g_destroy_func (elem), NULL));
		}
	}
	result = _result_;
	return result;
}

/**
     * Method to return a new Vala.SourceLocation from a reference shifted by a given offset.
     * 
     * @return The new Vala.SourceLocation
     */
void
vala_lint_utils_shift_location (ValaSourceLocation* reference,
                                gint offset,
                                ValaSourceLocation* result)
{
	ValaSourceLocation _result_ = {0};
	ValaSourceLocation _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (reference != NULL);
	_tmp0_ = *reference;
	_result_ = _tmp0_;
	_tmp1_ = _result_.pos;
	_result_.pos = _tmp1_ + offset;
	_result_.column = _result_.column + offset;
	*result = _result_;
	return;
}

ValaLintUtils*
vala_lint_utils_construct (GType object_type)
{
	ValaLintUtils * self = NULL;
	self = (ValaLintUtils*) g_object_new (object_type, NULL);
	return self;
}

ValaLintUtils*
vala_lint_utils_new (void)
{
	return vala_lint_utils_construct (VALA_LINT_TYPE_UTILS);
}

static void
vala_lint_utils_class_init (ValaLintUtilsClass * klass,
                            gpointer klass_data)
{
	vala_lint_utils_parent_class = g_type_class_peek_parent (klass);
}

static void
vala_lint_utils_instance_init (ValaLintUtils * self,
                               gpointer klass)
{
}

static GType
vala_lint_utils_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ValaLintUtilsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_lint_utils_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaLintUtils), 0, (GInstanceInitFunc) vala_lint_utils_instance_init, NULL };
	GType vala_lint_utils_type_id;
	vala_lint_utils_type_id = g_type_register_static (G_TYPE_OBJECT, "ValaLintUtils", &g_define_type_info, 0);
	return vala_lint_utils_type_id;
}

GType
vala_lint_utils_get_type (void)
{
	static volatile gsize vala_lint_utils_type_id__once = 0;
	if (g_once_init_enter (&vala_lint_utils_type_id__once)) {
		GType vala_lint_utils_type_id;
		vala_lint_utils_type_id = vala_lint_utils_get_type_once ();
		g_once_init_leave (&vala_lint_utils_type_id__once, vala_lint_utils_type_id);
	}
	return vala_lint_utils_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

