/* ValaVisitor.c generated by valac 0.56.3, the Vala compiler
 * generated from ValaVisitor.vala, do not modify */

/*
 * Copyright (c) 2018-2019 elementary LLC. (https://github.com/elementary/vala-lint)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */

#include <vala.h>
#include <glib-object.h>
#include <valagee.h>
#include "vala-linter.h"
#include <glib.h>

#define VALA_LINT_TYPE_VISITOR (vala_lint_visitor_get_type ())
#define VALA_LINT_VISITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALA_LINT_TYPE_VISITOR, ValaLintVisitor))
#define VALA_LINT_VISITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALA_LINT_TYPE_VISITOR, ValaLintVisitorClass))
#define VALA_LINT_IS_VISITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALA_LINT_TYPE_VISITOR))
#define VALA_LINT_IS_VISITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALA_LINT_TYPE_VISITOR))
#define VALA_LINT_VISITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALA_LINT_TYPE_VISITOR, ValaLintVisitorClass))

typedef struct _ValaLintVisitor ValaLintVisitor;
typedef struct _ValaLintVisitorClass ValaLintVisitorClass;
typedef struct _ValaLintVisitorPrivate ValaLintVisitorPrivate;
#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _ValaLintVisitor {
	ValaCodeVisitor parent_instance;
	ValaLintVisitorPrivate * priv;
	ValaArrayList* mistake_list;
	ValaLintChecksDoubleSemicolonCheck* double_semicolon_check;
	ValaLintChecksEllipsisCheck* ellipsis_check;
	ValaLintChecksNamingConventionCheck* naming_convention_check;
	ValaLintChecksUnnecessaryStringTemplateCheck* unnecessary_string_template_check;
	ValaLintChecksNoSpaceCheck* no_space_check;
};

struct _ValaLintVisitorClass {
	ValaCodeVisitorClass parent_class;
};

static gpointer vala_lint_visitor_parent_class = NULL;

VALA_EXTERN GType vala_lint_visitor_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void vala_lint_visitor_set_mistake_list (ValaLintVisitor* self,
                                         ValaArrayList* mistake_list);
static void vala_lint_visitor_real_visit_source_file (ValaCodeVisitor* base,
                                               ValaSourceFile* sf);
static void vala_lint_visitor_real_visit_namespace (ValaCodeVisitor* base,
                                             ValaNamespace* ns);
static void vala_lint_visitor_real_visit_class (ValaCodeVisitor* base,
                                         ValaClass* cl);
static void vala_lint_visitor_real_visit_struct (ValaCodeVisitor* base,
                                          ValaStruct* st);
static void vala_lint_visitor_real_visit_interface (ValaCodeVisitor* base,
                                             ValaInterface* iface);
static void vala_lint_visitor_real_visit_enum (ValaCodeVisitor* base,
                                        ValaEnum* en);
static void vala_lint_visitor_real_visit_enum_value (ValaCodeVisitor* base,
                                              ValaEnumValue* ev);
static void vala_lint_visitor_real_visit_error_domain (ValaCodeVisitor* base,
                                                ValaErrorDomain* edomain);
static void vala_lint_visitor_real_visit_error_code (ValaCodeVisitor* base,
                                              ValaErrorCode* ecode);
static void vala_lint_visitor_real_visit_delegate (ValaCodeVisitor* base,
                                            ValaDelegate* d);
static void vala_lint_visitor_real_visit_constant (ValaCodeVisitor* base,
                                            ValaConstant* c);
static void vala_lint_visitor_real_visit_field (ValaCodeVisitor* base,
                                         ValaField* f);
static void vala_lint_visitor_real_visit_method (ValaCodeVisitor* base,
                                          ValaMethod* m);
static void vala_lint_visitor_real_visit_creation_method (ValaCodeVisitor* base,
                                                   ValaCreationMethod* m);
static void vala_lint_visitor_real_visit_formal_parameter (ValaCodeVisitor* base,
                                                    ValaParameter* p);
static void vala_lint_visitor_real_visit_property (ValaCodeVisitor* base,
                                            ValaProperty* prop);
static void vala_lint_visitor_real_visit_property_accessor (ValaCodeVisitor* base,
                                                     ValaPropertyAccessor* acc);
static void vala_lint_visitor_real_visit_signal (ValaCodeVisitor* base,
                                          ValaSignal* sig);
static void vala_lint_visitor_real_visit_constructor (ValaCodeVisitor* base,
                                               ValaConstructor* c);
static void vala_lint_visitor_real_visit_destructor (ValaCodeVisitor* base,
                                              ValaDestructor* d);
static void vala_lint_visitor_real_visit_type_parameter (ValaCodeVisitor* base,
                                                  ValaTypeParameter* p);
static void vala_lint_visitor_real_visit_using_directive (ValaCodeVisitor* base,
                                                   ValaUsingDirective* ns);
static void vala_lint_visitor_real_visit_data_type (ValaCodeVisitor* base,
                                             ValaDataType* type);
static void vala_lint_visitor_real_visit_block (ValaCodeVisitor* base,
                                         ValaBlock* b);
static void vala_lint_visitor_real_visit_empty_statement (ValaCodeVisitor* base,
                                                   ValaEmptyStatement* stmt);
static void vala_lint_visitor_real_visit_declaration_statement (ValaCodeVisitor* base,
                                                         ValaDeclarationStatement* stmt);
static void vala_lint_visitor_real_visit_local_variable (ValaCodeVisitor* base,
                                                  ValaLocalVariable* local);
static void vala_lint_visitor_real_visit_initializer_list (ValaCodeVisitor* base,
                                                    ValaInitializerList* list);
static void vala_lint_visitor_real_visit_expression_statement (ValaCodeVisitor* base,
                                                        ValaExpressionStatement* stmt);
static void vala_lint_visitor_real_visit_if_statement (ValaCodeVisitor* base,
                                                ValaIfStatement* stmt);
static void vala_lint_visitor_real_visit_switch_statement (ValaCodeVisitor* base,
                                                    ValaSwitchStatement* stmt);
static void vala_lint_visitor_real_visit_switch_section (ValaCodeVisitor* base,
                                                  ValaSwitchSection* section);
static void vala_lint_visitor_real_visit_switch_label (ValaCodeVisitor* base,
                                                ValaSwitchLabel* label);
static void vala_lint_visitor_real_visit_loop_statement (ValaCodeVisitor* base,
                                                  ValaLoopStatement* stmt);
static void vala_lint_visitor_real_visit_while_statement (ValaCodeVisitor* base,
                                                   ValaWhileStatement* stmt);
static void vala_lint_visitor_real_visit_do_statement (ValaCodeVisitor* base,
                                                ValaDoStatement* stmt);
static void vala_lint_visitor_real_visit_for_statement (ValaCodeVisitor* base,
                                                 ValaForStatement* stmt);
static void vala_lint_visitor_real_visit_foreach_statement (ValaCodeVisitor* base,
                                                     ValaForeachStatement* stmt);
static void vala_lint_visitor_real_visit_break_statement (ValaCodeVisitor* base,
                                                   ValaBreakStatement* stmt);
static void vala_lint_visitor_real_visit_continue_statement (ValaCodeVisitor* base,
                                                      ValaContinueStatement* stmt);
static void vala_lint_visitor_real_visit_return_statement (ValaCodeVisitor* base,
                                                    ValaReturnStatement* stmt);
static void vala_lint_visitor_real_visit_yield_statement (ValaCodeVisitor* base,
                                                   ValaYieldStatement* y);
static void vala_lint_visitor_real_visit_throw_statement (ValaCodeVisitor* base,
                                                   ValaThrowStatement* stmt);
static void vala_lint_visitor_real_visit_try_statement (ValaCodeVisitor* base,
                                                 ValaTryStatement* stmt);
static void vala_lint_visitor_real_visit_catch_clause (ValaCodeVisitor* base,
                                                ValaCatchClause* clause);
static void vala_lint_visitor_real_visit_lock_statement (ValaCodeVisitor* base,
                                                  ValaLockStatement* stmt);
static void vala_lint_visitor_real_visit_unlock_statement (ValaCodeVisitor* base,
                                                    ValaUnlockStatement* stmt);
static void vala_lint_visitor_real_visit_with_statement (ValaCodeVisitor* base,
                                                  ValaWithStatement* stmt);
static void vala_lint_visitor_real_visit_delete_statement (ValaCodeVisitor* base,
                                                    ValaDeleteStatement* stmt);
static void vala_lint_visitor_real_visit_expression (ValaCodeVisitor* base,
                                              ValaExpression* expr);
static void vala_lint_visitor_real_visit_array_creation_expression (ValaCodeVisitor* base,
                                                             ValaArrayCreationExpression* expr);
static void vala_lint_visitor_real_visit_boolean_literal (ValaCodeVisitor* base,
                                                   ValaBooleanLiteral* lit);
static void vala_lint_visitor_real_visit_character_literal (ValaCodeVisitor* base,
                                                     ValaCharacterLiteral* lit);
static void vala_lint_visitor_real_visit_integer_literal (ValaCodeVisitor* base,
                                                   ValaIntegerLiteral* lit);
static void vala_lint_visitor_real_visit_real_literal (ValaCodeVisitor* base,
                                                ValaRealLiteral* lit);
static void vala_lint_visitor_real_visit_regex_literal (ValaCodeVisitor* base,
                                                 ValaRegexLiteral* lit);
static void vala_lint_visitor_real_visit_string_literal (ValaCodeVisitor* base,
                                                  ValaStringLiteral* lit);
static void vala_lint_visitor_real_visit_template (ValaCodeVisitor* base,
                                            ValaTemplate* tmpl);
static void vala_lint_visitor_real_visit_tuple (ValaCodeVisitor* base,
                                         ValaTuple* tuple);
static void vala_lint_visitor_real_visit_null_literal (ValaCodeVisitor* base,
                                                ValaNullLiteral* lit);
static void vala_lint_visitor_real_visit_member_access (ValaCodeVisitor* base,
                                                 ValaMemberAccess* expr);
static void vala_lint_visitor_real_visit_method_call (ValaCodeVisitor* base,
                                               ValaMethodCall* expr);
static void vala_lint_visitor_real_visit_element_access (ValaCodeVisitor* base,
                                                  ValaElementAccess* expr);
static void vala_lint_visitor_real_visit_slice_expression (ValaCodeVisitor* base,
                                                    ValaSliceExpression* expr);
static void vala_lint_visitor_real_visit_base_access (ValaCodeVisitor* base,
                                               ValaBaseAccess* expr);
static void vala_lint_visitor_real_visit_postfix_expression (ValaCodeVisitor* base,
                                                      ValaPostfixExpression* expr);
static void vala_lint_visitor_real_visit_object_creation_expression (ValaCodeVisitor* base,
                                                              ValaObjectCreationExpression* expr);
static void vala_lint_visitor_real_visit_sizeof_expression (ValaCodeVisitor* base,
                                                     ValaSizeofExpression* expr);
static void vala_lint_visitor_real_visit_typeof_expression (ValaCodeVisitor* base,
                                                     ValaTypeofExpression* expr);
static void vala_lint_visitor_real_visit_unary_expression (ValaCodeVisitor* base,
                                                    ValaUnaryExpression* expr);
static void vala_lint_visitor_real_visit_cast_expression (ValaCodeVisitor* base,
                                                   ValaCastExpression* expr);
static void vala_lint_visitor_real_visit_named_argument (ValaCodeVisitor* base,
                                                  ValaNamedArgument* expr);
static void vala_lint_visitor_real_visit_pointer_indirection (ValaCodeVisitor* base,
                                                       ValaPointerIndirection* expr);
static void vala_lint_visitor_real_visit_addressof_expression (ValaCodeVisitor* base,
                                                        ValaAddressofExpression* expr);
static void vala_lint_visitor_real_visit_reference_transfer_expression (ValaCodeVisitor* base,
                                                                 ValaReferenceTransferExpression* expr);
static void vala_lint_visitor_real_visit_binary_expression (ValaCodeVisitor* base,
                                                     ValaBinaryExpression* expr);
static void vala_lint_visitor_real_visit_type_check (ValaCodeVisitor* base,
                                              ValaTypeCheck* expr);
static void vala_lint_visitor_real_visit_conditional_expression (ValaCodeVisitor* base,
                                                          ValaConditionalExpression* expr);
static void vala_lint_visitor_real_visit_lambda_expression (ValaCodeVisitor* base,
                                                     ValaLambdaExpression* expr);
static void vala_lint_visitor_real_visit_assignment (ValaCodeVisitor* base,
                                              ValaAssignment* a);
static void vala_lint_visitor_real_visit_end_full_expression (ValaCodeVisitor* base,
                                                       ValaExpression* expr);
VALA_EXTERN ValaLintVisitor* vala_lint_visitor_new (void);
VALA_EXTERN ValaLintVisitor* vala_lint_visitor_construct (GType object_type);
static void vala_lint_visitor_finalize (ValaCodeVisitor * obj);
static GType vala_lint_visitor_get_type_once (void);

static gpointer
_vala_iterable_ref0 (gpointer self)
{
	return self ? vala_iterable_ref (self) : NULL;
}

void
vala_lint_visitor_set_mistake_list (ValaLintVisitor* self,
                                    ValaArrayList* mistake_list)
{
	ValaArrayList* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (mistake_list != NULL);
	_tmp0_ = _vala_iterable_ref0 (mistake_list);
	_vala_iterable_unref0 (self->mistake_list);
	self->mistake_list = _tmp0_;
}

static void
vala_lint_visitor_real_visit_source_file (ValaCodeVisitor* base,
                                          ValaSourceFile* sf)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (sf != NULL);
	vala_source_file_accept_children (sf, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_namespace (ValaCodeVisitor* base,
                                        ValaNamespace* ns)
{
	ValaLintVisitor * self;
	ValaLintChecksNamingConventionCheck* _tmp0_;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (ns != NULL);
	_tmp0_ = self->naming_convention_check;
	vala_lint_checks_naming_convention_check_check_camel_case (_tmp0_, (ValaSymbol*) ns, &self->mistake_list);
	vala_code_node_accept_children ((ValaCodeNode*) ns, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_class (ValaCodeVisitor* base,
                                    ValaClass* cl)
{
	ValaLintVisitor * self;
	ValaLintChecksNamingConventionCheck* _tmp0_;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (cl != NULL);
	_tmp0_ = self->naming_convention_check;
	vala_lint_checks_naming_convention_check_check_camel_case (_tmp0_, (ValaSymbol*) cl, &self->mistake_list);
	vala_code_node_accept_children ((ValaCodeNode*) cl, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_struct (ValaCodeVisitor* base,
                                     ValaStruct* st)
{
	ValaLintVisitor * self;
	ValaLintChecksNamingConventionCheck* _tmp0_;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (st != NULL);
	_tmp0_ = self->naming_convention_check;
	vala_lint_checks_naming_convention_check_check_camel_case (_tmp0_, (ValaSymbol*) st, &self->mistake_list);
	vala_code_node_accept_children ((ValaCodeNode*) st, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_interface (ValaCodeVisitor* base,
                                        ValaInterface* iface)
{
	ValaLintVisitor * self;
	ValaLintChecksNamingConventionCheck* _tmp0_;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (iface != NULL);
	_tmp0_ = self->naming_convention_check;
	vala_lint_checks_naming_convention_check_check_camel_case (_tmp0_, (ValaSymbol*) iface, &self->mistake_list);
	vala_code_node_accept_children ((ValaCodeNode*) iface, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_enum (ValaCodeVisitor* base,
                                   ValaEnum* en)
{
	ValaLintVisitor * self;
	ValaLintChecksNamingConventionCheck* _tmp0_;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (en != NULL);
	_tmp0_ = self->naming_convention_check;
	vala_lint_checks_naming_convention_check_check_camel_case (_tmp0_, (ValaSymbol*) en, &self->mistake_list);
	vala_code_node_accept_children ((ValaCodeNode*) en, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_enum_value (ValaCodeVisitor* base,
                                         ValaEnumValue* ev)
{
	ValaLintVisitor * self;
	ValaLintChecksNamingConventionCheck* _tmp0_;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (ev != NULL);
	_tmp0_ = self->naming_convention_check;
	vala_lint_checks_naming_convention_check_check_all_caps (_tmp0_, (ValaSymbol*) ev, &self->mistake_list);
	vala_code_node_accept_children ((ValaCodeNode*) ev, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_error_domain (ValaCodeVisitor* base,
                                           ValaErrorDomain* edomain)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (edomain != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) edomain, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_error_code (ValaCodeVisitor* base,
                                         ValaErrorCode* ecode)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (ecode != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) ecode, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_delegate (ValaCodeVisitor* base,
                                       ValaDelegate* d)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (d != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) d, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_constant (ValaCodeVisitor* base,
                                       ValaConstant* c)
{
	ValaLintVisitor * self;
	ValaLintChecksNamingConventionCheck* _tmp0_;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (c != NULL);
	_tmp0_ = self->naming_convention_check;
	vala_lint_checks_naming_convention_check_check_all_caps (_tmp0_, (ValaSymbol*) c, &self->mistake_list);
	vala_code_node_accept_children ((ValaCodeNode*) c, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_field (ValaCodeVisitor* base,
                                    ValaField* f)
{
	ValaLintVisitor * self;
	ValaLintChecksNamingConventionCheck* _tmp0_;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (f != NULL);
	_tmp0_ = self->naming_convention_check;
	vala_lint_checks_naming_convention_check_check_underscore (_tmp0_, (ValaSymbol*) f, &self->mistake_list);
	vala_code_node_accept_children ((ValaCodeNode*) f, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_method (ValaCodeVisitor* base,
                                     ValaMethod* m)
{
	ValaLintVisitor * self;
	ValaLintChecksNamingConventionCheck* _tmp0_;
	ValaLintChecksNoSpaceCheck* _tmp1_;
	ValaList* _tmp2_;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (m != NULL);
	_tmp0_ = self->naming_convention_check;
	vala_lint_checks_naming_convention_check_check_underscore (_tmp0_, (ValaSymbol*) m, &self->mistake_list);
	_tmp1_ = self->no_space_check;
	_tmp2_ = vala_callable_get_parameters ((ValaCallable*) m);
	vala_lint_checks_no_space_check_check_list (_tmp1_, _tmp2_, &self->mistake_list);
	vala_code_node_accept_children ((ValaCodeNode*) m, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_creation_method (ValaCodeVisitor* base,
                                              ValaCreationMethod* m)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (m != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) m, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_formal_parameter (ValaCodeVisitor* base,
                                               ValaParameter* p)
{
	ValaLintVisitor * self;
	ValaLintChecksNamingConventionCheck* _tmp0_;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (p != NULL);
	_tmp0_ = self->naming_convention_check;
	vala_lint_checks_naming_convention_check_check_underscore (_tmp0_, (ValaSymbol*) p, &self->mistake_list);
	vala_code_node_accept_children ((ValaCodeNode*) p, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_property (ValaCodeVisitor* base,
                                       ValaProperty* prop)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (prop != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) prop, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_property_accessor (ValaCodeVisitor* base,
                                                ValaPropertyAccessor* acc)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (acc != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) acc, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_signal (ValaCodeVisitor* base,
                                     ValaSignal* sig)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (sig != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) sig, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_constructor (ValaCodeVisitor* base,
                                          ValaConstructor* c)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (c != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) c, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_destructor (ValaCodeVisitor* base,
                                         ValaDestructor* d)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (d != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) d, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_type_parameter (ValaCodeVisitor* base,
                                             ValaTypeParameter* p)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (p != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) p, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_using_directive (ValaCodeVisitor* base,
                                              ValaUsingDirective* ns)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (ns != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) ns, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_data_type (ValaCodeVisitor* base,
                                        ValaDataType* type)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (type != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) type, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_block (ValaCodeVisitor* base,
                                    ValaBlock* b)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (b != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) b, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_empty_statement (ValaCodeVisitor* base,
                                              ValaEmptyStatement* stmt)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (stmt != NULL);
}

static void
vala_lint_visitor_real_visit_declaration_statement (ValaCodeVisitor* base,
                                                    ValaDeclarationStatement* stmt)
{
	ValaLintVisitor * self;
	ValaLintChecksDoubleSemicolonCheck* _tmp0_;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->double_semicolon_check;
	vala_lint_checks_double_semicolon_check_check_statement (_tmp0_, (ValaCodeNode*) stmt, &self->mistake_list);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_local_variable (ValaCodeVisitor* base,
                                             ValaLocalVariable* local)
{
	ValaLintVisitor * self;
	ValaLintChecksNamingConventionCheck* _tmp0_;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (local != NULL);
	_tmp0_ = self->naming_convention_check;
	vala_lint_checks_naming_convention_check_check_underscore (_tmp0_, (ValaSymbol*) local, &self->mistake_list);
	vala_code_node_accept_children ((ValaCodeNode*) local, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_initializer_list (ValaCodeVisitor* base,
                                               ValaInitializerList* list)
{
	ValaLintVisitor * self;
	ValaLintChecksNoSpaceCheck* _tmp0_;
	ValaList* _tmp1_;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (list != NULL);
	_tmp0_ = self->no_space_check;
	_tmp1_ = vala_initializer_list_get_initializers (list);
	vala_lint_checks_no_space_check_check_list (_tmp0_, _tmp1_, &self->mistake_list);
	vala_code_node_accept_children ((ValaCodeNode*) list, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_expression_statement (ValaCodeVisitor* base,
                                                   ValaExpressionStatement* stmt)
{
	ValaLintVisitor * self;
	ValaLintChecksDoubleSemicolonCheck* _tmp0_;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->double_semicolon_check;
	vala_lint_checks_double_semicolon_check_check_statement (_tmp0_, (ValaCodeNode*) stmt, &self->mistake_list);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_if_statement (ValaCodeVisitor* base,
                                           ValaIfStatement* stmt)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_switch_statement (ValaCodeVisitor* base,
                                               ValaSwitchStatement* stmt)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_switch_section (ValaCodeVisitor* base,
                                             ValaSwitchSection* section)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (section != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) section, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_switch_label (ValaCodeVisitor* base,
                                           ValaSwitchLabel* label)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (label != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) label, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_loop_statement (ValaCodeVisitor* base,
                                             ValaLoopStatement* stmt)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_while_statement (ValaCodeVisitor* base,
                                              ValaWhileStatement* stmt)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_do_statement (ValaCodeVisitor* base,
                                           ValaDoStatement* stmt)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_for_statement (ValaCodeVisitor* base,
                                            ValaForStatement* stmt)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_foreach_statement (ValaCodeVisitor* base,
                                                ValaForeachStatement* stmt)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_break_statement (ValaCodeVisitor* base,
                                              ValaBreakStatement* stmt)
{
	ValaLintVisitor * self;
	ValaLintChecksDoubleSemicolonCheck* _tmp0_;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->double_semicolon_check;
	vala_lint_checks_double_semicolon_check_check_statement (_tmp0_, (ValaCodeNode*) stmt, &self->mistake_list);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_continue_statement (ValaCodeVisitor* base,
                                                 ValaContinueStatement* stmt)
{
	ValaLintVisitor * self;
	ValaLintChecksDoubleSemicolonCheck* _tmp0_;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->double_semicolon_check;
	vala_lint_checks_double_semicolon_check_check_statement (_tmp0_, (ValaCodeNode*) stmt, &self->mistake_list);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_return_statement (ValaCodeVisitor* base,
                                               ValaReturnStatement* stmt)
{
	ValaLintVisitor * self;
	ValaLintChecksDoubleSemicolonCheck* _tmp0_;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->double_semicolon_check;
	vala_lint_checks_double_semicolon_check_check_statement (_tmp0_, (ValaCodeNode*) stmt, &self->mistake_list);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_yield_statement (ValaCodeVisitor* base,
                                              ValaYieldStatement* y)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (y != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) y, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_throw_statement (ValaCodeVisitor* base,
                                              ValaThrowStatement* stmt)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_try_statement (ValaCodeVisitor* base,
                                            ValaTryStatement* stmt)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_catch_clause (ValaCodeVisitor* base,
                                           ValaCatchClause* clause)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (clause != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) clause, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_lock_statement (ValaCodeVisitor* base,
                                             ValaLockStatement* stmt)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_unlock_statement (ValaCodeVisitor* base,
                                               ValaUnlockStatement* stmt)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_with_statement (ValaCodeVisitor* base,
                                             ValaWithStatement* stmt)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_delete_statement (ValaCodeVisitor* base,
                                               ValaDeleteStatement* stmt)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_expression (ValaCodeVisitor* base,
                                         ValaExpression* expr)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (expr != NULL);
}

static void
vala_lint_visitor_real_visit_array_creation_expression (ValaCodeVisitor* base,
                                                        ValaArrayCreationExpression* expr)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (expr != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_boolean_literal (ValaCodeVisitor* base,
                                              ValaBooleanLiteral* lit)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (lit != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) lit, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_character_literal (ValaCodeVisitor* base,
                                                ValaCharacterLiteral* lit)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (lit != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) lit, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_integer_literal (ValaCodeVisitor* base,
                                              ValaIntegerLiteral* lit)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (lit != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) lit, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_real_literal (ValaCodeVisitor* base,
                                           ValaRealLiteral* lit)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (lit != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) lit, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_regex_literal (ValaCodeVisitor* base,
                                            ValaRegexLiteral* lit)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (lit != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) lit, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_string_literal (ValaCodeVisitor* base,
                                             ValaStringLiteral* lit)
{
	ValaLintVisitor * self;
	ValaLintChecksEllipsisCheck* _tmp0_;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (lit != NULL);
	_tmp0_ = self->ellipsis_check;
	vala_lint_checks_ellipsis_check_check_string_literal (_tmp0_, lit, &self->mistake_list);
	vala_code_node_accept_children ((ValaCodeNode*) lit, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_template (ValaCodeVisitor* base,
                                       ValaTemplate* tmpl)
{
	ValaLintVisitor * self;
	ValaLintChecksUnnecessaryStringTemplateCheck* _tmp0_;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (tmpl != NULL);
	_tmp0_ = self->unnecessary_string_template_check;
	vala_lint_checks_unnecessary_string_template_check_check_template (_tmp0_, tmpl, &self->mistake_list);
	vala_code_node_accept_children ((ValaCodeNode*) tmpl, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_tuple (ValaCodeVisitor* base,
                                    ValaTuple* tuple)
{
	ValaLintVisitor * self;
	ValaLintChecksNoSpaceCheck* _tmp0_;
	ValaList* _tmp1_;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (tuple != NULL);
	_tmp0_ = self->no_space_check;
	_tmp1_ = vala_tuple_get_expressions (tuple);
	vala_lint_checks_no_space_check_check_list (_tmp0_, _tmp1_, &self->mistake_list);
	vala_code_node_accept_children ((ValaCodeNode*) tuple, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_null_literal (ValaCodeVisitor* base,
                                           ValaNullLiteral* lit)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (lit != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) lit, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_member_access (ValaCodeVisitor* base,
                                            ValaMemberAccess* expr)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (expr != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_method_call (ValaCodeVisitor* base,
                                          ValaMethodCall* expr)
{
	ValaLintVisitor * self;
	ValaLintChecksNoSpaceCheck* _tmp0_;
	ValaList* _tmp1_;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->no_space_check;
	_tmp1_ = vala_callable_expression_get_argument_list ((ValaCallableExpression*) expr);
	vala_lint_checks_no_space_check_check_list (_tmp0_, _tmp1_, &self->mistake_list);
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_element_access (ValaCodeVisitor* base,
                                             ValaElementAccess* expr)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (expr != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_slice_expression (ValaCodeVisitor* base,
                                               ValaSliceExpression* expr)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (expr != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_base_access (ValaCodeVisitor* base,
                                          ValaBaseAccess* expr)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (expr != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_postfix_expression (ValaCodeVisitor* base,
                                                 ValaPostfixExpression* expr)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (expr != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_object_creation_expression (ValaCodeVisitor* base,
                                                         ValaObjectCreationExpression* expr)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (expr != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_sizeof_expression (ValaCodeVisitor* base,
                                                ValaSizeofExpression* expr)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (expr != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_typeof_expression (ValaCodeVisitor* base,
                                                ValaTypeofExpression* expr)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (expr != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_unary_expression (ValaCodeVisitor* base,
                                               ValaUnaryExpression* expr)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (expr != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_cast_expression (ValaCodeVisitor* base,
                                              ValaCastExpression* expr)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (expr != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_named_argument (ValaCodeVisitor* base,
                                             ValaNamedArgument* expr)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (expr != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_pointer_indirection (ValaCodeVisitor* base,
                                                  ValaPointerIndirection* expr)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (expr != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_addressof_expression (ValaCodeVisitor* base,
                                                   ValaAddressofExpression* expr)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (expr != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_reference_transfer_expression (ValaCodeVisitor* base,
                                                            ValaReferenceTransferExpression* expr)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (expr != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_binary_expression (ValaCodeVisitor* base,
                                                ValaBinaryExpression* expr)
{
	ValaLintVisitor * self;
	ValaLintChecksNoSpaceCheck* _tmp0_;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->no_space_check;
	vala_lint_checks_no_space_check_check_binary_expression (_tmp0_, expr, &self->mistake_list);
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_type_check (ValaCodeVisitor* base,
                                         ValaTypeCheck* expr)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (expr != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_conditional_expression (ValaCodeVisitor* base,
                                                     ValaConditionalExpression* expr)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (expr != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_lambda_expression (ValaCodeVisitor* base,
                                                ValaLambdaExpression* expr)
{
	ValaLintVisitor * self;
	ValaLintChecksNoSpaceCheck* _tmp0_;
	ValaList* _tmp1_;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->no_space_check;
	_tmp1_ = vala_lambda_expression_get_parameters (expr);
	vala_lint_checks_no_space_check_check_list (_tmp0_, _tmp1_, &self->mistake_list);
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_assignment (ValaCodeVisitor* base,
                                         ValaAssignment* a)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (a != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) a, (ValaCodeVisitor*) self);
}

static void
vala_lint_visitor_real_visit_end_full_expression (ValaCodeVisitor* base,
                                                  ValaExpression* expr)
{
	ValaLintVisitor * self;
	self = (ValaLintVisitor*) base;
	g_return_if_fail (expr != NULL);
}

ValaLintVisitor*
vala_lint_visitor_construct (GType object_type)
{
	ValaLintVisitor* self = NULL;
	self = (ValaLintVisitor*) vala_code_visitor_construct (object_type);
	return self;
}

ValaLintVisitor*
vala_lint_visitor_new (void)
{
	return vala_lint_visitor_construct (VALA_LINT_TYPE_VISITOR);
}

static void
vala_lint_visitor_class_init (ValaLintVisitorClass * klass,
                              gpointer klass_data)
{
	vala_lint_visitor_parent_class = g_type_class_peek_parent (klass);
	((ValaCodeVisitorClass *) klass)->finalize = vala_lint_visitor_finalize;
	((ValaCodeVisitorClass *) klass)->visit_source_file = (void (*) (ValaCodeVisitor*, ValaSourceFile*)) vala_lint_visitor_real_visit_source_file;
	((ValaCodeVisitorClass *) klass)->visit_namespace = (void (*) (ValaCodeVisitor*, ValaNamespace*)) vala_lint_visitor_real_visit_namespace;
	((ValaCodeVisitorClass *) klass)->visit_class = (void (*) (ValaCodeVisitor*, ValaClass*)) vala_lint_visitor_real_visit_class;
	((ValaCodeVisitorClass *) klass)->visit_struct = (void (*) (ValaCodeVisitor*, ValaStruct*)) vala_lint_visitor_real_visit_struct;
	((ValaCodeVisitorClass *) klass)->visit_interface = (void (*) (ValaCodeVisitor*, ValaInterface*)) vala_lint_visitor_real_visit_interface;
	((ValaCodeVisitorClass *) klass)->visit_enum = (void (*) (ValaCodeVisitor*, ValaEnum*)) vala_lint_visitor_real_visit_enum;
	((ValaCodeVisitorClass *) klass)->visit_enum_value = (void (*) (ValaCodeVisitor*, ValaEnumValue*)) vala_lint_visitor_real_visit_enum_value;
	((ValaCodeVisitorClass *) klass)->visit_error_domain = (void (*) (ValaCodeVisitor*, ValaErrorDomain*)) vala_lint_visitor_real_visit_error_domain;
	((ValaCodeVisitorClass *) klass)->visit_error_code = (void (*) (ValaCodeVisitor*, ValaErrorCode*)) vala_lint_visitor_real_visit_error_code;
	((ValaCodeVisitorClass *) klass)->visit_delegate = (void (*) (ValaCodeVisitor*, ValaDelegate*)) vala_lint_visitor_real_visit_delegate;
	((ValaCodeVisitorClass *) klass)->visit_constant = (void (*) (ValaCodeVisitor*, ValaConstant*)) vala_lint_visitor_real_visit_constant;
	((ValaCodeVisitorClass *) klass)->visit_field = (void (*) (ValaCodeVisitor*, ValaField*)) vala_lint_visitor_real_visit_field;
	((ValaCodeVisitorClass *) klass)->visit_method = (void (*) (ValaCodeVisitor*, ValaMethod*)) vala_lint_visitor_real_visit_method;
	((ValaCodeVisitorClass *) klass)->visit_creation_method = (void (*) (ValaCodeVisitor*, ValaCreationMethod*)) vala_lint_visitor_real_visit_creation_method;
	((ValaCodeVisitorClass *) klass)->visit_formal_parameter = (void (*) (ValaCodeVisitor*, ValaParameter*)) vala_lint_visitor_real_visit_formal_parameter;
	((ValaCodeVisitorClass *) klass)->visit_property = (void (*) (ValaCodeVisitor*, ValaProperty*)) vala_lint_visitor_real_visit_property;
	((ValaCodeVisitorClass *) klass)->visit_property_accessor = (void (*) (ValaCodeVisitor*, ValaPropertyAccessor*)) vala_lint_visitor_real_visit_property_accessor;
	((ValaCodeVisitorClass *) klass)->visit_signal = (void (*) (ValaCodeVisitor*, ValaSignal*)) vala_lint_visitor_real_visit_signal;
	((ValaCodeVisitorClass *) klass)->visit_constructor = (void (*) (ValaCodeVisitor*, ValaConstructor*)) vala_lint_visitor_real_visit_constructor;
	((ValaCodeVisitorClass *) klass)->visit_destructor = (void (*) (ValaCodeVisitor*, ValaDestructor*)) vala_lint_visitor_real_visit_destructor;
	((ValaCodeVisitorClass *) klass)->visit_type_parameter = (void (*) (ValaCodeVisitor*, ValaTypeParameter*)) vala_lint_visitor_real_visit_type_parameter;
	((ValaCodeVisitorClass *) klass)->visit_using_directive = (void (*) (ValaCodeVisitor*, ValaUsingDirective*)) vala_lint_visitor_real_visit_using_directive;
	((ValaCodeVisitorClass *) klass)->visit_data_type = (void (*) (ValaCodeVisitor*, ValaDataType*)) vala_lint_visitor_real_visit_data_type;
	((ValaCodeVisitorClass *) klass)->visit_block = (void (*) (ValaCodeVisitor*, ValaBlock*)) vala_lint_visitor_real_visit_block;
	((ValaCodeVisitorClass *) klass)->visit_empty_statement = (void (*) (ValaCodeVisitor*, ValaEmptyStatement*)) vala_lint_visitor_real_visit_empty_statement;
	((ValaCodeVisitorClass *) klass)->visit_declaration_statement = (void (*) (ValaCodeVisitor*, ValaDeclarationStatement*)) vala_lint_visitor_real_visit_declaration_statement;
	((ValaCodeVisitorClass *) klass)->visit_local_variable = (void (*) (ValaCodeVisitor*, ValaLocalVariable*)) vala_lint_visitor_real_visit_local_variable;
	((ValaCodeVisitorClass *) klass)->visit_initializer_list = (void (*) (ValaCodeVisitor*, ValaInitializerList*)) vala_lint_visitor_real_visit_initializer_list;
	((ValaCodeVisitorClass *) klass)->visit_expression_statement = (void (*) (ValaCodeVisitor*, ValaExpressionStatement*)) vala_lint_visitor_real_visit_expression_statement;
	((ValaCodeVisitorClass *) klass)->visit_if_statement = (void (*) (ValaCodeVisitor*, ValaIfStatement*)) vala_lint_visitor_real_visit_if_statement;
	((ValaCodeVisitorClass *) klass)->visit_switch_statement = (void (*) (ValaCodeVisitor*, ValaSwitchStatement*)) vala_lint_visitor_real_visit_switch_statement;
	((ValaCodeVisitorClass *) klass)->visit_switch_section = (void (*) (ValaCodeVisitor*, ValaSwitchSection*)) vala_lint_visitor_real_visit_switch_section;
	((ValaCodeVisitorClass *) klass)->visit_switch_label = (void (*) (ValaCodeVisitor*, ValaSwitchLabel*)) vala_lint_visitor_real_visit_switch_label;
	((ValaCodeVisitorClass *) klass)->visit_loop_statement = (void (*) (ValaCodeVisitor*, ValaLoopStatement*)) vala_lint_visitor_real_visit_loop_statement;
	((ValaCodeVisitorClass *) klass)->visit_while_statement = (void (*) (ValaCodeVisitor*, ValaWhileStatement*)) vala_lint_visitor_real_visit_while_statement;
	((ValaCodeVisitorClass *) klass)->visit_do_statement = (void (*) (ValaCodeVisitor*, ValaDoStatement*)) vala_lint_visitor_real_visit_do_statement;
	((ValaCodeVisitorClass *) klass)->visit_for_statement = (void (*) (ValaCodeVisitor*, ValaForStatement*)) vala_lint_visitor_real_visit_for_statement;
	((ValaCodeVisitorClass *) klass)->visit_foreach_statement = (void (*) (ValaCodeVisitor*, ValaForeachStatement*)) vala_lint_visitor_real_visit_foreach_statement;
	((ValaCodeVisitorClass *) klass)->visit_break_statement = (void (*) (ValaCodeVisitor*, ValaBreakStatement*)) vala_lint_visitor_real_visit_break_statement;
	((ValaCodeVisitorClass *) klass)->visit_continue_statement = (void (*) (ValaCodeVisitor*, ValaContinueStatement*)) vala_lint_visitor_real_visit_continue_statement;
	((ValaCodeVisitorClass *) klass)->visit_return_statement = (void (*) (ValaCodeVisitor*, ValaReturnStatement*)) vala_lint_visitor_real_visit_return_statement;
	((ValaCodeVisitorClass *) klass)->visit_yield_statement = (void (*) (ValaCodeVisitor*, ValaYieldStatement*)) vala_lint_visitor_real_visit_yield_statement;
	((ValaCodeVisitorClass *) klass)->visit_throw_statement = (void (*) (ValaCodeVisitor*, ValaThrowStatement*)) vala_lint_visitor_real_visit_throw_statement;
	((ValaCodeVisitorClass *) klass)->visit_try_statement = (void (*) (ValaCodeVisitor*, ValaTryStatement*)) vala_lint_visitor_real_visit_try_statement;
	((ValaCodeVisitorClass *) klass)->visit_catch_clause = (void (*) (ValaCodeVisitor*, ValaCatchClause*)) vala_lint_visitor_real_visit_catch_clause;
	((ValaCodeVisitorClass *) klass)->visit_lock_statement = (void (*) (ValaCodeVisitor*, ValaLockStatement*)) vala_lint_visitor_real_visit_lock_statement;
	((ValaCodeVisitorClass *) klass)->visit_unlock_statement = (void (*) (ValaCodeVisitor*, ValaUnlockStatement*)) vala_lint_visitor_real_visit_unlock_statement;
	((ValaCodeVisitorClass *) klass)->visit_with_statement = (void (*) (ValaCodeVisitor*, ValaWithStatement*)) vala_lint_visitor_real_visit_with_statement;
	((ValaCodeVisitorClass *) klass)->visit_delete_statement = (void (*) (ValaCodeVisitor*, ValaDeleteStatement*)) vala_lint_visitor_real_visit_delete_statement;
	((ValaCodeVisitorClass *) klass)->visit_expression = (void (*) (ValaCodeVisitor*, ValaExpression*)) vala_lint_visitor_real_visit_expression;
	((ValaCodeVisitorClass *) klass)->visit_array_creation_expression = (void (*) (ValaCodeVisitor*, ValaArrayCreationExpression*)) vala_lint_visitor_real_visit_array_creation_expression;
	((ValaCodeVisitorClass *) klass)->visit_boolean_literal = (void (*) (ValaCodeVisitor*, ValaBooleanLiteral*)) vala_lint_visitor_real_visit_boolean_literal;
	((ValaCodeVisitorClass *) klass)->visit_character_literal = (void (*) (ValaCodeVisitor*, ValaCharacterLiteral*)) vala_lint_visitor_real_visit_character_literal;
	((ValaCodeVisitorClass *) klass)->visit_integer_literal = (void (*) (ValaCodeVisitor*, ValaIntegerLiteral*)) vala_lint_visitor_real_visit_integer_literal;
	((ValaCodeVisitorClass *) klass)->visit_real_literal = (void (*) (ValaCodeVisitor*, ValaRealLiteral*)) vala_lint_visitor_real_visit_real_literal;
	((ValaCodeVisitorClass *) klass)->visit_regex_literal = (void (*) (ValaCodeVisitor*, ValaRegexLiteral*)) vala_lint_visitor_real_visit_regex_literal;
	((ValaCodeVisitorClass *) klass)->visit_string_literal = (void (*) (ValaCodeVisitor*, ValaStringLiteral*)) vala_lint_visitor_real_visit_string_literal;
	((ValaCodeVisitorClass *) klass)->visit_template = (void (*) (ValaCodeVisitor*, ValaTemplate*)) vala_lint_visitor_real_visit_template;
	((ValaCodeVisitorClass *) klass)->visit_tuple = (void (*) (ValaCodeVisitor*, ValaTuple*)) vala_lint_visitor_real_visit_tuple;
	((ValaCodeVisitorClass *) klass)->visit_null_literal = (void (*) (ValaCodeVisitor*, ValaNullLiteral*)) vala_lint_visitor_real_visit_null_literal;
	((ValaCodeVisitorClass *) klass)->visit_member_access = (void (*) (ValaCodeVisitor*, ValaMemberAccess*)) vala_lint_visitor_real_visit_member_access;
	((ValaCodeVisitorClass *) klass)->visit_method_call = (void (*) (ValaCodeVisitor*, ValaMethodCall*)) vala_lint_visitor_real_visit_method_call;
	((ValaCodeVisitorClass *) klass)->visit_element_access = (void (*) (ValaCodeVisitor*, ValaElementAccess*)) vala_lint_visitor_real_visit_element_access;
	((ValaCodeVisitorClass *) klass)->visit_slice_expression = (void (*) (ValaCodeVisitor*, ValaSliceExpression*)) vala_lint_visitor_real_visit_slice_expression;
	((ValaCodeVisitorClass *) klass)->visit_base_access = (void (*) (ValaCodeVisitor*, ValaBaseAccess*)) vala_lint_visitor_real_visit_base_access;
	((ValaCodeVisitorClass *) klass)->visit_postfix_expression = (void (*) (ValaCodeVisitor*, ValaPostfixExpression*)) vala_lint_visitor_real_visit_postfix_expression;
	((ValaCodeVisitorClass *) klass)->visit_object_creation_expression = (void (*) (ValaCodeVisitor*, ValaObjectCreationExpression*)) vala_lint_visitor_real_visit_object_creation_expression;
	((ValaCodeVisitorClass *) klass)->visit_sizeof_expression = (void (*) (ValaCodeVisitor*, ValaSizeofExpression*)) vala_lint_visitor_real_visit_sizeof_expression;
	((ValaCodeVisitorClass *) klass)->visit_typeof_expression = (void (*) (ValaCodeVisitor*, ValaTypeofExpression*)) vala_lint_visitor_real_visit_typeof_expression;
	((ValaCodeVisitorClass *) klass)->visit_unary_expression = (void (*) (ValaCodeVisitor*, ValaUnaryExpression*)) vala_lint_visitor_real_visit_unary_expression;
	((ValaCodeVisitorClass *) klass)->visit_cast_expression = (void (*) (ValaCodeVisitor*, ValaCastExpression*)) vala_lint_visitor_real_visit_cast_expression;
	((ValaCodeVisitorClass *) klass)->visit_named_argument = (void (*) (ValaCodeVisitor*, ValaNamedArgument*)) vala_lint_visitor_real_visit_named_argument;
	((ValaCodeVisitorClass *) klass)->visit_pointer_indirection = (void (*) (ValaCodeVisitor*, ValaPointerIndirection*)) vala_lint_visitor_real_visit_pointer_indirection;
	((ValaCodeVisitorClass *) klass)->visit_addressof_expression = (void (*) (ValaCodeVisitor*, ValaAddressofExpression*)) vala_lint_visitor_real_visit_addressof_expression;
	((ValaCodeVisitorClass *) klass)->visit_reference_transfer_expression = (void (*) (ValaCodeVisitor*, ValaReferenceTransferExpression*)) vala_lint_visitor_real_visit_reference_transfer_expression;
	((ValaCodeVisitorClass *) klass)->visit_binary_expression = (void (*) (ValaCodeVisitor*, ValaBinaryExpression*)) vala_lint_visitor_real_visit_binary_expression;
	((ValaCodeVisitorClass *) klass)->visit_type_check = (void (*) (ValaCodeVisitor*, ValaTypeCheck*)) vala_lint_visitor_real_visit_type_check;
	((ValaCodeVisitorClass *) klass)->visit_conditional_expression = (void (*) (ValaCodeVisitor*, ValaConditionalExpression*)) vala_lint_visitor_real_visit_conditional_expression;
	((ValaCodeVisitorClass *) klass)->visit_lambda_expression = (void (*) (ValaCodeVisitor*, ValaLambdaExpression*)) vala_lint_visitor_real_visit_lambda_expression;
	((ValaCodeVisitorClass *) klass)->visit_assignment = (void (*) (ValaCodeVisitor*, ValaAssignment*)) vala_lint_visitor_real_visit_assignment;
	((ValaCodeVisitorClass *) klass)->visit_end_full_expression = (void (*) (ValaCodeVisitor*, ValaExpression*)) vala_lint_visitor_real_visit_end_full_expression;
}

static void
vala_lint_visitor_instance_init (ValaLintVisitor * self,
                                 gpointer klass)
{
}

static void
vala_lint_visitor_finalize (ValaCodeVisitor * obj)
{
	ValaLintVisitor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_LINT_TYPE_VISITOR, ValaLintVisitor);
	_vala_iterable_unref0 (self->mistake_list);
	_g_object_unref0 (self->double_semicolon_check);
	_g_object_unref0 (self->ellipsis_check);
	_g_object_unref0 (self->naming_convention_check);
	_g_object_unref0 (self->unnecessary_string_template_check);
	_g_object_unref0 (self->no_space_check);
	VALA_CODE_VISITOR_CLASS (vala_lint_visitor_parent_class)->finalize (obj);
}

static GType
vala_lint_visitor_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ValaLintVisitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_lint_visitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaLintVisitor), 0, (GInstanceInitFunc) vala_lint_visitor_instance_init, NULL };
	GType vala_lint_visitor_type_id;
	vala_lint_visitor_type_id = g_type_register_static (VALA_TYPE_CODE_VISITOR, "ValaLintVisitor", &g_define_type_info, 0);
	return vala_lint_visitor_type_id;
}

GType
vala_lint_visitor_get_type (void)
{
	static volatile gsize vala_lint_visitor_type_id__once = 0;
	if (g_once_init_enter (&vala_lint_visitor_type_id__once)) {
		GType vala_lint_visitor_type_id;
		vala_lint_visitor_type_id = vala_lint_visitor_get_type_once ();
		g_once_init_leave (&vala_lint_visitor_type_id__once, vala_lint_visitor_type_id);
	}
	return vala_lint_visitor_type_id__once;
}

