/* Application.c generated by valac 0.56.3, the Vala compiler
 * generated from Application.vala, do not modify */

/*
 * Copyright (c) 2016-2019 elementary LLC. (https://github.com/elementary/vala-lint)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Marcus Wichelmann <marcus.wichelmann@hotmail.de>
 */

#define _GNU_SOURCE

#include <gio/gio.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <fnmatch.h>
#include <glib/gi18n-lib.h>
#include "vala-linter.h"
#include <glib/gstdio.h>
#include <valagee.h>
#include <glob.h>
#include <vala.h>

#define VALA_LINT_APPLICATION_VERSION "0.1"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define VALA_LINT_TYPE_APPLICATION (vala_lint_application_get_type ())
#define VALA_LINT_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALA_LINT_TYPE_APPLICATION, ValaLintApplication))
#define VALA_LINT_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALA_LINT_TYPE_APPLICATION, ValaLintApplicationClass))
#define VALA_LINT_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALA_LINT_TYPE_APPLICATION))
#define VALA_LINT_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALA_LINT_TYPE_APPLICATION))
#define VALA_LINT_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALA_LINT_TYPE_APPLICATION, ValaLintApplicationClass))

typedef struct _ValaLintApplication ValaLintApplication;
typedef struct _ValaLintApplicationClass ValaLintApplicationClass;
typedef struct _ValaLintApplicationPrivate ValaLintApplicationPrivate;
enum  {
	VALA_LINT_APPLICATION_0_PROPERTY,
	VALA_LINT_APPLICATION_NUM_PROPERTIES
};
static GParamSpec* vala_lint_application_properties[VALA_LINT_APPLICATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_option_context_free0(var) ((var == NULL) ? NULL : (var = (g_option_context_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))

#define VALA_LINT_TYPE_FILE_DATA (vala_lint_file_data_get_type ())
typedef struct _ValaLintFileData ValaLintFileData;
#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))
#define _vala_lint_file_data_free0(var) ((var == NULL) ? NULL : (var = (vala_lint_file_data_free (var), NULL)))
#define __vala_ValaLintFormatMistake_free0(var) ((var == NULL) ? NULL : (var = (_vala_ValaLintFormatMistake_free (var), NULL)))

struct _ValaLintApplication {
	GApplication parent_instance;
	ValaLintApplicationPrivate * priv;
};

struct _ValaLintApplicationClass {
	GApplicationClass parent_class;
};

struct _ValaLintApplicationPrivate {
	GApplicationCommandLine* application_command_line;
};

struct _ValaLintFileData {
	GFile* file;
	gchar* name;
	ValaArrayList* mistakes;
};

static gint ValaLintApplication_private_offset;
static gpointer vala_lint_application_parent_class = NULL;
static gboolean vala_lint_application_print_version;
static gchar* vala_lint_application_lint_directory;
static gboolean vala_lint_application_print_mistakes_end;
static gchar* vala_lint_application_config_file;
static gboolean vala_lint_application_exit_with_zero;
static gboolean vala_lint_application_generate_config_file;
static gboolean vala_lint_application_auto_fix;
static gchar* vala_lint_application_lint_directory = NULL;
static gboolean vala_lint_application_print_version = FALSE;
static gboolean vala_lint_application_print_mistakes_end = FALSE;
static gboolean vala_lint_application_exit_with_zero = FALSE;
static gboolean vala_lint_application_generate_config_file = FALSE;
static gboolean vala_lint_application_auto_fix = FALSE;
static gchar* vala_lint_application_config_file = NULL;
static gchar* vala_lint_application_ignore_pattern_list;
static gchar* vala_lint_application_ignore_pattern_list = NULL;
static gint vala_lint_application_fnmatch_flags;
static gint vala_lint_application_fnmatch_flags = (FNM_EXTMATCH | FNM_PERIOD) | FNM_PATHNAME;
static GFile* vala_lint_application_root_dir;
static GFile* vala_lint_application_root_dir = NULL;

VALA_EXTERN GType vala_lint_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ValaLintApplication, g_object_unref)
static ValaLintApplication* vala_lint_application_new (void);
static ValaLintApplication* vala_lint_application_construct (GType object_type);
static gint vala_lint_application_real_command_line (GApplication* base,
                                              GApplicationCommandLine* command_line);
static gint vala_lint_application_handle_command_line (ValaLintApplication* self,
                                                GApplicationCommandLine* command_line);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
VALA_EXTERN GType vala_lint_file_data_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ValaLintFileData* vala_lint_file_data_dup (const ValaLintFileData* self);
VALA_EXTERN void vala_lint_file_data_free (ValaLintFileData* self);
VALA_EXTERN void vala_lint_file_data_copy (const ValaLintFileData* self,
                               ValaLintFileData* dest);
VALA_EXTERN void vala_lint_file_data_destroy (ValaLintFileData* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (ValaLintFileData, vala_lint_file_data_destroy)
static gchar** _vala_array_dup1 (gchar** self,
                          gssize length);
static void _vala_array_add2 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static ValaArrayList* vala_lint_application_get_files (ValaLintApplication* self,
                                                GApplicationCommandLine* command_line,
                                                gchar** patterns,
                                                gint patterns_length1,
                                                gchar** ignore_patterns,
                                                gint ignore_patterns_length1,
                                                GError** error);
static gboolean vala_lint_application_print_mistakes (ValaLintApplication* self,
                                               ValaArrayList* file_data_list);
static void _vala_ValaLintFormatMistake_free (ValaLintFormatMistake* self);
static ValaLintFormatMistake* _vala_lint_format_mistake_dup (ValaLintFormatMistake* self);
static ValaArrayList* vala_lint_application_get_files_from_directory (ValaLintApplication* self,
                                                               GFile* dir,
                                                               GError** error);
static gchar* vala_lint_application_apply_color_for_state (ValaLintApplication* self,
                                                    const gchar* str,
                                                    ValaLintConfigState state);
static gint vala_lint_application_main (gchar** args,
                                 gint args_length1);
static void vala_lint_application_finalize (GObject * obj);
static GType vala_lint_application_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static const GOptionEntry VALA_LINT_APPLICATION_OPTIONS[8] = {{"version", 'v', (gint) 0, G_OPTION_ARG_NONE, &vala_lint_application_print_version, "Display version number."}, {"directory", 'd', (gint) G_OPTION_FLAG_HIDDEN, G_OPTION_ARG_STRING, &vala_lint_application_lint_directory, "Lint all Vala files in the given directory. (DEPRECEATED)"}, {"print-end", 'e', (gint) 0, G_OPTION_ARG_NONE, &vala_lint_application_print_mistakes_end, "Show end of mistakes."}, {"config", 'c', (gint) 0, G_OPTION_ARG_STRING, &vala_lint_application_config_file, "Specify a configuration file."}, {"exit-zero", 'z', (gint) 0, G_OPTION_ARG_NONE, &vala_lint_application_exit_with_zero, "Always return a 0 (non-error) status code, even if lint errors are fou" \
"nd."}, {"generate-config", 'g', (gint) 0, G_OPTION_ARG_NONE, &vala_lint_application_generate_config_file, "Generate a sample configuration file with default values."}, {"fix", 'f', (gint) 0, G_OPTION_ARG_NONE, &vala_lint_application_auto_fix, "Fix any auto-fixable mistakes."}, {NULL}};

static inline gpointer
vala_lint_application_get_instance_private (ValaLintApplication* self)
{
	return G_STRUCT_MEMBER_P (self, ValaLintApplication_private_offset);
}

static ValaLintApplication*
vala_lint_application_construct (GType object_type)
{
	ValaLintApplication * self = NULL;
	self = (ValaLintApplication*) g_object_new (object_type, "application-id", "io.elementary.vala-lint", "flags", G_APPLICATION_HANDLES_COMMAND_LINE, NULL);
	return self;
}

static ValaLintApplication*
vala_lint_application_new (void)
{
	return vala_lint_application_construct (VALA_LINT_TYPE_APPLICATION);
}

static gint
vala_lint_application_real_command_line (GApplication* base,
                                         GApplicationCommandLine* command_line)
{
	ValaLintApplication * self;
	gint res = 0;
	gint result;
	self = (ValaLintApplication*) base;
	g_return_val_if_fail (command_line != NULL, 0);
	g_application_hold ((GApplication*) self);
	res = vala_lint_application_handle_command_line (self, command_line);
	g_application_release ((GApplication*) self);
	result = res;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	if (start < ((glong) 0)) {
		start = string_length + start;
	}
	if (end < ((glong) 0)) {
		end = string_length + end;
	}
	if (start >= ((glong) 0)) {
		_tmp2_ = start <= string_length;
	} else {
		_tmp2_ = FALSE;
	}
	g_return_val_if_fail (_tmp2_, NULL);
	if (end >= ((glong) 0)) {
		_tmp3_ = end <= string_length;
	} else {
		_tmp3_ = FALSE;
	}
	g_return_val_if_fail (_tmp3_, NULL);
	g_return_val_if_fail (start <= end, NULL);
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
	result = _tmp4_;
	return result;
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static gchar**
_vala_array_dup1 (gchar** self,
                  gssize length)
{
	if (length >= 0) {
		gchar** result;
		gssize i;
		result = g_new0 (gchar*, length + 1);
		for (i = 0; i < length; i++) {
			gchar* _tmp0_;
			_tmp0_ = g_strdup (self[i]);
			result[i] = _tmp0_;
		}
		return result;
	}
	return NULL;
}

static void
_vala_array_add2 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_ValaLintFormatMistake_free (ValaLintFormatMistake* self)
{
	vala_lint_format_mistake_destroy (self);
	g_free (self);
}

static gint
vala_lint_application_handle_command_line (ValaLintApplication* self,
                                           GApplicationCommandLine* command_line)
{
	gchar** args = NULL;
	gint _tmp0_ = 0;
	gchar** _tmp1_;
	gint args_length1;
	gint _args_size_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar** tmp = NULL;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gint tmp_length1;
	gint _tmp_size_;
	GApplicationCommandLine* _tmp29_;
	gchar** ignore_patterns = NULL;
	gchar** _tmp30_;
	gint ignore_patterns_length1;
	gint _ignore_patterns_size_;
	const gchar* _tmp31_ = NULL;
	const gchar* _tmp32_;
	gchar* ignore_root = NULL;
	gchar* _tmp36_;
	const gchar* _tmp37_;
	gchar* ignore_filepath = NULL;
	const gchar* _tmp40_;
	gchar* _tmp41_;
	gchar* fallback_path = NULL;
	const gchar* _tmp42_;
	gchar* _tmp43_;
	const gchar* _tmp44_;
	const gchar* _tmp51_;
	gchar* contents = NULL;
	gsize size = 0UL;
	ValaArrayList* file_data_list = NULL;
	GEqualFunc _tmp90_;
	ValaArrayList* _tmp91_;
	const gchar* _tmp108_;
	ValaLintLinter* linter = NULL;
	ValaLintLinter* _tmp109_;
	ValaLintFixer* fixer = NULL;
	ValaLintFixer* _tmp110_;
	gboolean has_errors = FALSE;
	ValaArrayList* _tmp142_;
	gboolean _tmp143_ = FALSE;
	GError* _inner_error0_ = NULL;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (command_line != NULL, 0);
	_tmp1_ = g_application_command_line_get_arguments (command_line, &_tmp0_);
	args = _tmp1_;
	args_length1 = _tmp0_;
	_args_size_ = args_length1;
	_tmp2_ = args;
	_tmp2__length1 = args_length1;
	if (_tmp2__length1 == 1) {
		gchar** _tmp3_;
		gint _tmp3__length1;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar** _tmp7_;
		_tmp3_ = args;
		_tmp3__length1 = args_length1;
		_tmp4_ = _tmp3_[0];
		_tmp5_ = g_strdup (_tmp4_);
		_tmp6_ = g_strdup (".");
		_tmp7_ = g_new0 (gchar*, 2 + 1);
		_tmp7_[0] = _tmp5_;
		_tmp7_[1] = _tmp6_;
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
		args = _tmp7_;
		args_length1 = 2;
		_args_size_ = args_length1;
	}
	_tmp8_ = args;
	_tmp8__length1 = args_length1;
	tmp = _tmp8_;
	tmp_length1 = _tmp8__length1;
	_tmp_size_ = tmp_length1;
	{
		GOptionContext* option_context = NULL;
		GOptionContext* _tmp9_;
		GOptionContext* _tmp10_;
		GOptionContext* _tmp11_;
		GOptionContext* _tmp12_;
		_tmp9_ = g_option_context_new ("- Vala-Lint");
		option_context = _tmp9_;
		_tmp10_ = option_context;
		g_option_context_set_help_enabled (_tmp10_, TRUE);
		_tmp11_ = option_context;
		g_option_context_add_main_entries (_tmp11_, VALA_LINT_APPLICATION_OPTIONS, NULL);
		_tmp12_ = option_context;
		g_option_context_parse (_tmp12_, (gint*) (&tmp_length1), &tmp, &_inner_error0_);
		_tmp_size_ = tmp_length1;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gint _tmp13_ = -1;
			_g_option_context_free0 (option_context);
			if (_inner_error0_->domain == G_OPTION_ERROR) {
				goto __catch0_g_option_error;
			}
			args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp13_;
		}
		_g_option_context_free0 (option_context);
	}
	goto __finally0;
	__catch0_g_option_error:
	{
		GError* e = NULL;
		gchar* _tmp14_;
		gchar* _tmp15_;
		GError* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar** _tmp20_;
		gint _tmp20__length1;
		const gchar* _tmp21_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp14_ = g_strconcat (_ ("Error: %s"), "\n", NULL);
		_tmp15_ = _tmp14_;
		_tmp16_ = e;
		_tmp17_ = _tmp16_->message;
		g_application_command_line_print (command_line, _tmp15_, _tmp17_);
		_g_free0 (_tmp15_);
		_tmp18_ = g_strconcat (_ ("Run '%s --help' to see a full list of available options."), "\n", NULL);
		_tmp19_ = _tmp18_;
		_tmp20_ = args;
		_tmp20__length1 = args_length1;
		_tmp21_ = _tmp20_[0];
		g_application_command_line_print (command_line, _tmp19_, _tmp21_);
		_g_free0 (_tmp19_);
		result = 1;
		_g_error_free0 (e);
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gint _tmp22_ = -1;
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp22_;
	}
	if (vala_lint_application_print_version) {
		gchar* _tmp23_;
		gchar* _tmp24_;
		_tmp23_ = g_strconcat (_ ("Version: %s"), "\n", NULL);
		_tmp24_ = _tmp23_;
		g_application_command_line_print (command_line, _tmp24_, VALA_LINT_APPLICATION_VERSION);
		_g_free0 (_tmp24_);
		result = 0;
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	if (vala_lint_application_generate_config_file) {
		GKeyFile* default_config = NULL;
		GKeyFile* _tmp25_;
		GKeyFile* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		_tmp25_ = vala_lint_config_get_default_config ();
		default_config = _tmp25_;
		_tmp26_ = default_config;
		_tmp27_ = g_key_file_to_data (_tmp26_, NULL, NULL);
		_tmp28_ = _tmp27_;
		g_application_command_line_print (command_line, "%s", _tmp28_);
		_g_free0 (_tmp28_);
		result = 0;
		_g_key_file_unref0 (default_config);
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	_tmp29_ = _g_object_ref0 (command_line);
	_g_object_unref0 (self->priv->application_command_line);
	self->priv->application_command_line = _tmp29_;
	_tmp30_ = g_new0 (gchar*, 0 + 1);
	ignore_patterns = _tmp30_;
	ignore_patterns_length1 = 0;
	_ignore_patterns_size_ = ignore_patterns_length1;
	_tmp32_ = vala_lint_application_lint_directory;
	if (_tmp32_ != NULL) {
		const gchar* _tmp33_;
		_tmp33_ = vala_lint_application_lint_directory;
		_tmp31_ = _tmp33_;
	} else {
		gchar** _tmp34_;
		gint _tmp34__length1;
		const gchar* _tmp35_;
		_tmp34_ = args;
		_tmp34__length1 = args_length1;
		_tmp35_ = _tmp34_[1];
		_tmp31_ = _tmp35_;
	}
	_tmp36_ = g_strdup (_tmp31_);
	ignore_root = _tmp36_;
	_tmp37_ = ignore_root;
	if (g_str_has_suffix (_tmp37_, G_DIR_SEPARATOR_S)) {
		const gchar* _tmp38_;
		gchar* _tmp39_;
		_tmp38_ = ignore_root;
		_tmp39_ = string_slice (_tmp38_, (glong) 0, (glong) -1);
		_g_free0 (ignore_root);
		ignore_root = _tmp39_;
	}
	_tmp40_ = ignore_root;
	_tmp41_ = g_build_filename (_tmp40_, ".valalintignore", NULL);
	ignore_filepath = _tmp41_;
	_tmp42_ = g_get_home_dir ();
	_tmp43_ = g_build_filename (_tmp42_, ".valalintignore", NULL);
	fallback_path = _tmp43_;
	_tmp44_ = ignore_filepath;
	if (!g_path_is_absolute (_tmp44_)) {
		GFile* ignore_file = NULL;
		const gchar* _tmp45_;
		GApplicationCommandLine* _tmp46_;
		const gchar* _tmp47_;
		GFile* _tmp48_;
		GFile* _tmp49_;
		gchar* _tmp50_;
		_tmp45_ = ignore_filepath;
		_tmp46_ = self->priv->application_command_line;
		_tmp47_ = g_application_command_line_get_cwd (_tmp46_);
		_tmp48_ = g_file_new_for_commandline_arg_and_cwd (_tmp45_, _tmp47_);
		ignore_file = _tmp48_;
		_tmp49_ = ignore_file;
		_tmp50_ = g_file_get_path (_tmp49_);
		_g_free0 (ignore_filepath);
		ignore_filepath = _tmp50_;
		_g_object_unref0 (ignore_file);
	}
	_tmp51_ = ignore_filepath;
	g_debug ("Application.vala:128: Absolute ignore file path %s", _tmp51_);
	size = (gsize) 0;
	{
		const gchar* _tmp52_;
		gchar* _tmp53_ = NULL;
		gsize _tmp54_ = 0UL;
		_tmp52_ = ignore_filepath;
		g_file_get_contents (_tmp52_, &_tmp53_, &_tmp54_, &_inner_error0_);
		_g_free0 (contents);
		contents = _tmp53_;
		size = _tmp54_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp55_;
		const gchar* _tmp56_;
		gchar* _tmp57_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp55_ = e;
		_tmp56_ = _tmp55_->message;
		g_debug ("Application.vala:135: Error loading ignore file contents: %s", _tmp56_);
		_tmp57_ = g_strdup ("");
		_g_free0 (contents);
		contents = _tmp57_;
		size = (gsize) 0;
		_g_error_free0 (e);
	}
	__finally1:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gint _tmp58_ = -1;
		_g_free0 (contents);
		_g_free0 (fallback_path);
		_g_free0 (ignore_filepath);
		_g_free0 (ignore_root);
		ignore_patterns = (_vala_array_free (ignore_patterns, ignore_patterns_length1, (GDestroyNotify) g_free), NULL);
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp58_;
	}
	if (size == ((gsize) 0)) {
		{
			const gchar* _tmp59_;
			gchar* _tmp60_ = NULL;
			gsize _tmp61_ = 0UL;
			_tmp59_ = fallback_path;
			g_file_get_contents (_tmp59_, &_tmp60_, &_tmp61_, &_inner_error0_);
			_g_free0 (contents);
			contents = _tmp60_;
			size = _tmp61_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch2_g_error;
			}
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError* e = NULL;
			GError* _tmp62_;
			const gchar* _tmp63_;
			gchar* _tmp64_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp62_ = e;
			_tmp63_ = _tmp62_->message;
			g_debug ("Application.vala:144: Error loading ignore file contents: %s", _tmp63_);
			_tmp64_ = g_strdup ("");
			_g_free0 (contents);
			contents = _tmp64_;
			size = (gsize) 0;
			_g_error_free0 (e);
		}
		__finally2:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gint _tmp65_ = -1;
			_g_free0 (contents);
			_g_free0 (fallback_path);
			_g_free0 (ignore_filepath);
			_g_free0 (ignore_root);
			ignore_patterns = (_vala_array_free (ignore_patterns, ignore_patterns_length1, (GDestroyNotify) g_free), NULL);
			args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp65_;
		}
	}
	if (size > ((gsize) 10000UL)) {
		gchar* _tmp66_;
		gchar* _tmp67_;
		const gchar* _tmp68_;
		_tmp66_ = g_strconcat (_ ("%s is too large and will not be used."), "\n", NULL);
		_tmp67_ = _tmp66_;
		_tmp68_ = ignore_filepath;
		g_application_command_line_print (command_line, _tmp67_, _tmp68_);
		_g_free0 (_tmp67_);
	} else {
		if (size > ((gsize) 0)) {
			gchar** ignore_split = NULL;
			const gchar* _tmp69_;
			gchar** _tmp70_;
			gchar** _tmp71_;
			gint ignore_split_length1;
			gint _ignore_split_size_;
			gchar** _tmp72_;
			gint _tmp72__length1;
			_tmp69_ = contents;
			_tmp71_ = _tmp70_ = g_strsplit (_tmp69_, "\n", -1);
			ignore_split = _tmp71_;
			ignore_split_length1 = _vala_array_length (_tmp70_);
			_ignore_split_size_ = ignore_split_length1;
			_tmp72_ = ignore_split;
			_tmp72__length1 = ignore_split_length1;
			{
				gchar** ignore_collection = NULL;
				gint ignore_collection_length1 = 0;
				gint _ignore_collection_size_ = 0;
				gint ignore_it = 0;
				ignore_collection = _tmp72_;
				ignore_collection_length1 = _tmp72__length1;
				for (ignore_it = 0; ignore_it < ignore_collection_length1; ignore_it = ignore_it + 1) {
					gchar* _tmp73_;
					gchar* ignore = NULL;
					_tmp73_ = g_strdup (ignore_collection[ignore_it]);
					ignore = _tmp73_;
					{
						gboolean _tmp74_ = FALSE;
						const gchar* _tmp75_;
						_tmp75_ = ignore;
						if (g_strcmp0 (_tmp75_, "") != 0) {
							const gchar* _tmp76_;
							gint _tmp77_;
							gint _tmp78_;
							_tmp76_ = ignore;
							_tmp77_ = strlen (_tmp76_);
							_tmp78_ = _tmp77_;
							_tmp74_ = _tmp78_ <= 255;
						} else {
							_tmp74_ = FALSE;
						}
						if (_tmp74_) {
							const gchar* _tmp79_;
							const gchar* _tmp82_;
							gchar* _tmp83_;
							_tmp79_ = ignore;
							if (g_str_has_suffix (_tmp79_, G_DIR_SEPARATOR_S)) {
								const gchar* _tmp80_;
								gchar* _tmp81_;
								_tmp80_ = ignore;
								_tmp81_ = string_slice (_tmp80_, (glong) 0, (glong) -1);
								_g_free0 (ignore);
								ignore = _tmp81_;
							}
							_tmp82_ = ignore;
							_tmp83_ = g_strdup (_tmp82_);
							_vala_array_add1 (&ignore_patterns, &ignore_patterns_length1, &_ignore_patterns_size_, _tmp83_);
						} else {
							const gchar* _tmp84_;
							gint _tmp85_;
							gint _tmp86_;
							_tmp84_ = ignore;
							_tmp85_ = strlen (_tmp84_);
							_tmp86_ = _tmp85_;
							if (_tmp86_ > 255) {
								gchar* _tmp87_;
								gchar* _tmp88_;
								const gchar* _tmp89_;
								_tmp87_ = g_strconcat (_ ("The pattern %s is too long and will not be used."), "\n", NULL);
								_tmp88_ = _tmp87_;
								_tmp89_ = ignore;
								g_application_command_line_print (command_line, _tmp88_, _tmp89_);
								_g_free0 (_tmp88_);
							}
						}
						_g_free0 (ignore);
					}
				}
			}
			ignore_split = (_vala_array_free (ignore_split, ignore_split_length1, (GDestroyNotify) g_free), NULL);
		}
	}
	_tmp90_ = g_direct_equal;
	_tmp91_ = vala_array_list_new (VALA_LINT_TYPE_FILE_DATA, (GBoxedCopyFunc) vala_lint_file_data_dup, (GDestroyNotify) vala_lint_file_data_free, _tmp90_);
	file_data_list = _tmp91_;
	{
		gchar** file_name_list = NULL;
		gchar** _tmp92_;
		gint _tmp92__length1;
		gchar** _tmp93_;
		gint _tmp93__length1;
		gchar** _tmp94_;
		gint _tmp94__length1;
		gint file_name_list_length1;
		gint _file_name_list_size_;
		const gchar* _tmp95_;
		ValaArrayList* _tmp98_ = NULL;
		gchar** _tmp99_;
		gint _tmp99__length1;
		gchar** _tmp100_;
		gint _tmp100__length1;
		ValaArrayList* _tmp101_;
		ValaArrayList* _tmp102_;
		_tmp92_ = tmp;
		_tmp92__length1 = tmp_length1;
		_tmp93_ = tmp;
		_tmp93__length1 = tmp_length1;
		_tmp94_ = (_tmp92_ != NULL) ? _vala_array_dup1 (_tmp92_ + 1, _tmp93__length1 - 1) : _tmp92_;
		_tmp94__length1 = _tmp93__length1 - 1;
		file_name_list = _tmp94_;
		file_name_list_length1 = _tmp94__length1;
		_file_name_list_size_ = file_name_list_length1;
		_tmp95_ = vala_lint_application_lint_directory;
		if (_tmp95_ != NULL) {
			const gchar* _tmp96_;
			gchar* _tmp97_;
			_tmp96_ = vala_lint_application_lint_directory;
			_tmp97_ = g_strdup (_tmp96_);
			_vala_array_add2 (&file_name_list, &file_name_list_length1, &_file_name_list_size_, _tmp97_);
		}
		_tmp99_ = file_name_list;
		_tmp99__length1 = file_name_list_length1;
		_tmp100_ = ignore_patterns;
		_tmp100__length1 = ignore_patterns_length1;
		_tmp101_ = vala_lint_application_get_files (self, command_line, _tmp99_, (gint) _tmp99__length1, _tmp100_, (gint) _tmp100__length1, &_inner_error0_);
		_tmp98_ = _tmp101_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			file_name_list = (_vala_array_free (file_name_list, file_name_list_length1, (GDestroyNotify) g_free), NULL);
			goto __catch3_g_error;
		}
		_tmp102_ = _tmp98_;
		_tmp98_ = NULL;
		_vala_iterable_unref0 (file_data_list);
		file_data_list = _tmp102_;
		_vala_iterable_unref0 (_tmp98_);
		file_name_list = (_vala_array_free (file_name_list, file_name_list_length1, (GDestroyNotify) g_free), NULL);
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* e = NULL;
		gchar* _tmp103_;
		gchar* _tmp104_;
		GError* _tmp105_;
		const gchar* _tmp106_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp103_ = g_strconcat (_ ("Error: %s"), "\n", NULL);
		_tmp104_ = _tmp103_;
		_tmp105_ = e;
		_tmp106_ = _tmp105_->message;
		g_critical (_tmp104_, _tmp106_);
		_g_free0 (_tmp104_);
		_g_error_free0 (e);
	}
	__finally3:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gint _tmp107_ = -1;
		_vala_iterable_unref0 (file_data_list);
		_g_free0 (contents);
		_g_free0 (fallback_path);
		_g_free0 (ignore_filepath);
		_g_free0 (ignore_root);
		ignore_patterns = (_vala_array_free (ignore_patterns, ignore_patterns_length1, (GDestroyNotify) g_free), NULL);
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp107_;
	}
	_tmp108_ = vala_lint_application_config_file;
	vala_lint_config_load_file (_tmp108_);
	_tmp109_ = vala_lint_linter_new ();
	linter = _tmp109_;
	_tmp110_ = vala_lint_fixer_new ();
	fixer = _tmp110_;
	{
		ValaArrayList* _data_list = NULL;
		ValaArrayList* _tmp111_;
		gint _data_size = 0;
		ValaArrayList* _tmp112_;
		gint _tmp113_;
		gint _tmp114_;
		gint _data_index = 0;
		_tmp111_ = file_data_list;
		_data_list = _tmp111_;
		_tmp112_ = _data_list;
		_tmp113_ = vala_collection_get_size ((ValaCollection*) _tmp112_);
		_tmp114_ = _tmp113_;
		_data_size = _tmp114_;
		_data_index = -1;
		while (TRUE) {
			gint _tmp115_;
			gint _tmp116_;
			ValaLintFileData data = {0};
			ValaArrayList* _tmp117_;
			gpointer _tmp118_;
			ValaLintFileData* _tmp119_;
			ValaLintFileData _tmp120_;
			ValaLintFileData _tmp121_ = {0};
			ValaLintFileData _tmp122_;
			_data_index = _data_index + 1;
			_tmp115_ = _data_index;
			_tmp116_ = _data_size;
			if (!(_tmp115_ < _tmp116_)) {
				break;
			}
			_tmp117_ = _data_list;
			_tmp118_ = vala_list_get ((ValaList*) _tmp117_, _data_index);
			_tmp119_ = (ValaLintFileData*) _tmp118_;
			_tmp120_ = *_tmp119_;
			vala_lint_file_data_copy (&_tmp120_, &_tmp121_);
			_tmp122_ = _tmp121_;
			_vala_lint_file_data_free0 (_tmp119_);
			data = _tmp122_;
			{
				ValaArrayList* mistakes = NULL;
				ValaLintLinter* _tmp123_;
				ValaLintFileData _tmp124_;
				GFile* _tmp125_;
				ValaArrayList* _tmp126_;
				ValaLintFileData _tmp130_;
				ValaArrayList* _tmp131_;
				ValaArrayList* _tmp132_;
				_tmp123_ = linter;
				_tmp124_ = data;
				_tmp125_ = _tmp124_.file;
				_tmp126_ = vala_lint_linter_run_checks_for_file (_tmp123_, _tmp125_, &_inner_error0_);
				mistakes = _tmp126_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					goto __catch4_g_error;
				}
				if (vala_lint_application_auto_fix) {
					ValaLintFixer* _tmp127_;
					ValaLintFileData _tmp128_;
					GFile* _tmp129_;
					_tmp127_ = fixer;
					_tmp128_ = data;
					_tmp129_ = _tmp128_.file;
					vala_lint_fixer_apply_fixes_for_file (_tmp127_, _tmp129_, &mistakes, &_inner_error0_);
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_vala_iterable_unref0 (mistakes);
						goto __catch4_g_error;
					}
				}
				_tmp130_ = data;
				_tmp131_ = _tmp130_.mistakes;
				_tmp132_ = mistakes;
				vala_collection_add_all ((ValaCollection*) _tmp131_, (ValaCollection*) _tmp132_);
				_vala_iterable_unref0 (mistakes);
			}
			goto __finally4;
			__catch4_g_error:
			{
				GError* e = NULL;
				gchar* _tmp133_;
				gchar* _tmp134_;
				GError* _tmp135_;
				const gchar* _tmp136_;
				ValaLintFileData _tmp137_;
				GFile* _tmp138_;
				gchar* _tmp139_;
				gchar* _tmp140_;
				e = _inner_error0_;
				_inner_error0_ = NULL;
				_tmp133_ = g_strconcat (_ ("Error: %s while linting file %s"), "\n", NULL);
				_tmp134_ = _tmp133_;
				_tmp135_ = e;
				_tmp136_ = _tmp135_->message;
				_tmp137_ = data;
				_tmp138_ = _tmp137_.file;
				_tmp139_ = g_file_get_path (_tmp138_);
				_tmp140_ = _tmp139_;
				g_critical (_tmp134_, _tmp136_, _tmp140_);
				_g_free0 (_tmp140_);
				_g_free0 (_tmp134_);
				_g_error_free0 (e);
			}
			__finally4:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				gint _tmp141_ = -1;
				vala_lint_file_data_destroy (&data);
				_g_object_unref0 (fixer);
				_g_object_unref0 (linter);
				_vala_iterable_unref0 (file_data_list);
				_g_free0 (contents);
				_g_free0 (fallback_path);
				_g_free0 (ignore_filepath);
				_g_free0 (ignore_root);
				ignore_patterns = (_vala_array_free (ignore_patterns, ignore_patterns_length1, (GDestroyNotify) g_free), NULL);
				args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp141_;
			}
			vala_lint_file_data_destroy (&data);
		}
	}
	_tmp142_ = file_data_list;
	has_errors = vala_lint_application_print_mistakes (self, _tmp142_);
	if (vala_lint_application_exit_with_zero) {
		_tmp143_ = TRUE;
	} else {
		_tmp143_ = !has_errors;
	}
	if (_tmp143_) {
		result = 0;
		_g_object_unref0 (fixer);
		_g_object_unref0 (linter);
		_vala_iterable_unref0 (file_data_list);
		_g_free0 (contents);
		_g_free0 (fallback_path);
		_g_free0 (ignore_filepath);
		_g_free0 (ignore_root);
		ignore_patterns = (_vala_array_free (ignore_patterns, ignore_patterns_length1, (GDestroyNotify) g_free), NULL);
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
		return result;
	} else {
		result = 1;
		_g_object_unref0 (fixer);
		_g_object_unref0 (linter);
		_vala_iterable_unref0 (file_data_list);
		_g_free0 (contents);
		_g_free0 (fallback_path);
		_g_free0 (ignore_filepath);
		_g_free0 (ignore_root);
		ignore_patterns = (_vala_array_free (ignore_patterns, ignore_patterns_length1, (GDestroyNotify) g_free), NULL);
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	{
		ValaArrayList* _file_data_list = NULL;
		ValaArrayList* _tmp144_;
		gint _file_data_size = 0;
		ValaArrayList* _tmp145_;
		gint _tmp146_;
		gint _tmp147_;
		gint _file_data_index = 0;
		_tmp144_ = file_data_list;
		_file_data_list = _tmp144_;
		_tmp145_ = _file_data_list;
		_tmp146_ = vala_collection_get_size ((ValaCollection*) _tmp145_);
		_tmp147_ = _tmp146_;
		_file_data_size = _tmp147_;
		_file_data_index = -1;
		while (TRUE) {
			gint _tmp148_;
			gint _tmp149_;
			ValaLintFileData file_data = {0};
			ValaArrayList* _tmp150_;
			gpointer _tmp151_;
			ValaLintFileData* _tmp152_;
			ValaLintFileData _tmp153_;
			ValaLintFileData _tmp154_ = {0};
			ValaLintFileData _tmp155_;
			_file_data_index = _file_data_index + 1;
			_tmp148_ = _file_data_index;
			_tmp149_ = _file_data_size;
			if (!(_tmp148_ < _tmp149_)) {
				break;
			}
			_tmp150_ = _file_data_list;
			_tmp151_ = vala_list_get ((ValaList*) _tmp150_, _file_data_index);
			_tmp152_ = (ValaLintFileData*) _tmp151_;
			_tmp153_ = *_tmp152_;
			vala_lint_file_data_copy (&_tmp153_, &_tmp154_);
			_tmp155_ = _tmp154_;
			_vala_lint_file_data_free0 (_tmp152_);
			file_data = _tmp155_;
			{
				ValaArrayList* _mistake_list = NULL;
				ValaLintFileData _tmp156_;
				ValaArrayList* _tmp157_;
				gint _mistake_size = 0;
				ValaArrayList* _tmp158_;
				gint _tmp159_;
				gint _tmp160_;
				gint _mistake_index = 0;
				_tmp156_ = file_data;
				_tmp157_ = _tmp156_.mistakes;
				_mistake_list = _tmp157_;
				_tmp158_ = _mistake_list;
				_tmp159_ = vala_collection_get_size ((ValaCollection*) _tmp158_);
				_tmp160_ = _tmp159_;
				_mistake_size = _tmp160_;
				_mistake_index = -1;
				while (TRUE) {
					gint _tmp161_;
					gint _tmp162_;
					ValaLintFormatMistake* mistake = NULL;
					ValaArrayList* _tmp163_;
					gpointer _tmp164_;
					ValaLintFormatMistake* _tmp165_;
					ValaLintCheck* _tmp166_;
					ValaLintConfigState _tmp167_;
					ValaLintConfigState _tmp168_;
					_mistake_index = _mistake_index + 1;
					_tmp161_ = _mistake_index;
					_tmp162_ = _mistake_size;
					if (!(_tmp161_ < _tmp162_)) {
						break;
					}
					_tmp163_ = _mistake_list;
					_tmp164_ = vala_list_get ((ValaList*) _tmp163_, _mistake_index);
					mistake = (ValaLintFormatMistake*) _tmp164_;
					_tmp165_ = mistake;
					_tmp166_ = (*_tmp165_).check;
					_tmp167_ = vala_lint_check_get_state (_tmp166_);
					_tmp168_ = _tmp167_;
					if (_tmp168_ == VALA_LINT_CONFIG_STATE_ERROR) {
						result = 1;
						__vala_ValaLintFormatMistake_free0 (mistake);
						vala_lint_file_data_destroy (&file_data);
						_g_object_unref0 (fixer);
						_g_object_unref0 (linter);
						_vala_iterable_unref0 (file_data_list);
						_g_free0 (contents);
						_g_free0 (fallback_path);
						_g_free0 (ignore_filepath);
						_g_free0 (ignore_root);
						ignore_patterns = (_vala_array_free (ignore_patterns, ignore_patterns_length1, (GDestroyNotify) g_free), NULL);
						args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
						return result;
					}
					__vala_ValaLintFormatMistake_free0 (mistake);
				}
			}
			vala_lint_file_data_destroy (&file_data);
		}
	}
	result = 0;
	_g_object_unref0 (fixer);
	_g_object_unref0 (linter);
	_vala_iterable_unref0 (file_data_list);
	_g_free0 (contents);
	_g_free0 (fallback_path);
	_g_free0 (ignore_filepath);
	_g_free0 (ignore_root);
	ignore_patterns = (_vala_array_free (ignore_patterns, ignore_patterns_length1, (GDestroyNotify) g_free), NULL);
	args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

static ValaLintFormatMistake*
_vala_lint_format_mistake_dup (ValaLintFormatMistake* self)
{
	ValaLintFormatMistake* dup;
	dup = g_new0 (ValaLintFormatMistake, 1);
	vala_lint_format_mistake_copy (self, dup);
	return dup;
}

static ValaArrayList*
vala_lint_application_get_files (ValaLintApplication* self,
                                 GApplicationCommandLine* command_line,
                                 gchar** patterns,
                                 gint patterns_length1,
                                 gchar** ignore_patterns,
                                 gint ignore_patterns_length1,
                                 GError** error)
{
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	ValaArrayList* _result_ = NULL;
	GEqualFunc _tmp19_;
	ValaArrayList* _tmp20_;
	GError* _inner_error0_ = NULL;
	ValaArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (command_line != NULL, NULL);
	{
		gchar** pattern_collection = NULL;
		gint pattern_collection_length1 = 0;
		gint _pattern_collection_size_ = 0;
		gint pattern_it = 0;
		pattern_collection = ignore_patterns;
		pattern_collection_length1 = ignore_patterns_length1;
		for (pattern_it = 0; pattern_it < pattern_collection_length1; pattern_it = pattern_it + 1) {
			gchar* _tmp0_;
			gchar* pattern = NULL;
			_tmp0_ = g_strdup (pattern_collection[pattern_it]);
			pattern = _tmp0_;
			{
				const gchar* _tmp1_;
				const gchar* _tmp2_;
				gchar* _tmp3_;
				gchar* _tmp4_;
				gchar* _tmp5_;
				_tmp1_ = vala_lint_application_ignore_pattern_list;
				_tmp2_ = pattern;
				_tmp3_ = g_strconcat ("|", _tmp2_, NULL);
				_tmp4_ = _tmp3_;
				_tmp5_ = g_strconcat (_tmp1_, _tmp4_, NULL);
				_g_free0 (vala_lint_application_ignore_pattern_list);
				vala_lint_application_ignore_pattern_list = _tmp5_;
				_g_free0 (_tmp4_);
				_g_free0 (pattern);
			}
		}
	}
	_tmp6_ = vala_lint_application_ignore_pattern_list;
	g_debug ("Application.vala:228: Ignore pattern list: %s", _tmp6_);
	_tmp7_ = vala_lint_application_ignore_pattern_list;
	_tmp8_ = strlen (_tmp7_);
	_tmp9_ = _tmp8_;
	if (_tmp9_ > 0) {
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		_tmp10_ = vala_lint_application_ignore_pattern_list;
		_tmp11_ = vala_lint_application_ignore_pattern_list;
		_tmp12_ = strlen (_tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = string_slice (_tmp10_, (glong) 1, (glong) _tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = g_strconcat ("+(", _tmp15_, NULL);
		_tmp17_ = _tmp16_;
		_tmp18_ = g_strconcat (_tmp17_, ")", NULL);
		_g_free0 (vala_lint_application_ignore_pattern_list);
		vala_lint_application_ignore_pattern_list = _tmp18_;
		_g_free0 (_tmp17_);
		_g_free0 (_tmp15_);
	}
	_tmp19_ = g_direct_equal;
	_tmp20_ = vala_array_list_new (VALA_LINT_TYPE_FILE_DATA, (GBoxedCopyFunc) vala_lint_file_data_dup, (GDestroyNotify) vala_lint_file_data_free, _tmp19_);
	_result_ = _tmp20_;
	{
		gchar** pattern_collection = NULL;
		gint pattern_collection_length1 = 0;
		gint _pattern_collection_size_ = 0;
		gint pattern_it = 0;
		pattern_collection = patterns;
		pattern_collection_length1 = patterns_length1;
		for (pattern_it = 0; pattern_it < pattern_collection_length1; pattern_it = pattern_it + 1) {
			gchar* _tmp21_;
			gchar* pattern = NULL;
			_tmp21_ = g_strdup (pattern_collection[pattern_it]);
			pattern = _tmp21_;
			{
				glob_t matcher = {0};
				const gchar* _tmp22_;
				glob_t _tmp26_;
				gchar** _tmp27_;
				gint _tmp27__length1;
				memset (&matcher, 0, sizeof (glob_t));
				_tmp22_ = pattern;
				if (glob (_tmp22_, 0, NULL, &matcher) != 0) {
					gchar* _tmp23_;
					gchar* _tmp24_;
					const gchar* _tmp25_;
					_tmp23_ = g_strconcat (_ ("No files found for pattern: %s"), "\n", NULL);
					_tmp24_ = _tmp23_;
					_tmp25_ = pattern;
					g_application_command_line_print (command_line, _tmp24_, _tmp25_);
					_g_free0 (_tmp24_);
					globfree (&matcher);
					_g_free0 (pattern);
					continue;
				}
				_tmp26_ = matcher;
				_tmp27_ = _tmp26_.gl_pathv;
				_tmp27__length1 = _vala_array_length (_tmp26_.gl_pathv);
				{
					gchar** path_collection = NULL;
					gint path_collection_length1 = 0;
					gint _path_collection_size_ = 0;
					gint path_it = 0;
					path_collection = _tmp27_;
					path_collection_length1 = _tmp27__length1;
					for (path_it = 0; path_it < path_collection_length1; path_it = path_it + 1) {
						gchar* _tmp28_;
						gchar* path = NULL;
						_tmp28_ = g_strdup (path_collection[path_it]);
						path = _tmp28_;
						{
							GFile* file = NULL;
							const gchar* _tmp29_;
							GFile* _tmp30_;
							GFileType file_type = 0;
							GFile* _tmp31_;
							_tmp29_ = path;
							_tmp30_ = g_file_new_for_path (_tmp29_);
							file = _tmp30_;
							_tmp31_ = file;
							file_type = g_file_query_file_type (_tmp31_, G_FILE_QUERY_INFO_NONE, NULL);
							switch (file_type) {
								case G_FILE_TYPE_REGULAR:
								{
									ValaArrayList* _tmp32_;
									GFile* _tmp33_;
									const gchar* _tmp34_;
									GEqualFunc _tmp35_;
									ValaArrayList* _tmp36_;
									ValaArrayList* _tmp37_;
									ValaLintFileData _tmp38_ = {0};
									_tmp32_ = _result_;
									_tmp33_ = file;
									_tmp34_ = path;
									_tmp35_ = g_direct_equal;
									_tmp36_ = vala_array_list_new (VALA_LINT_TYPE_FORMAT_MISTAKE, (GBoxedCopyFunc) _vala_lint_format_mistake_dup, (GDestroyNotify) _vala_ValaLintFormatMistake_free, _tmp35_);
									_tmp37_ = _tmp36_;
									_g_object_unref0 (_tmp38_.file);
									_tmp38_.file = _tmp33_;
									_g_free0 (_tmp38_.name);
									_tmp38_.name = _tmp34_;
									_vala_iterable_unref0 (_tmp38_.mistakes);
									_tmp38_.mistakes = _tmp37_;
									vala_collection_add ((ValaCollection*) _tmp32_, &_tmp38_);
									_vala_iterable_unref0 (_tmp37_);
									break;
								}
								case G_FILE_TYPE_DIRECTORY:
								{
									GFile* _tmp39_;
									GFile* _tmp40_;
									ValaArrayList* _tmp41_ = NULL;
									GFile* _tmp42_;
									ValaArrayList* _tmp43_;
									_tmp39_ = file;
									_tmp40_ = _g_object_ref0 (_tmp39_);
									_g_object_unref0 (vala_lint_application_root_dir);
									vala_lint_application_root_dir = _tmp40_;
									_tmp42_ = file;
									_tmp43_ = vala_lint_application_get_files_from_directory (self, _tmp42_, &_inner_error0_);
									_tmp41_ = _tmp43_;
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
										g_propagate_error (error, _inner_error0_);
										_g_object_unref0 (file);
										_g_free0 (path);
										globfree (&matcher);
										_g_free0 (pattern);
										_vala_iterable_unref0 (_result_);
										return NULL;
									}
									{
										ValaArrayList* _f_list = NULL;
										gint _f_size = 0;
										ValaArrayList* _tmp44_;
										gint _tmp45_;
										gint _tmp46_;
										gint _f_index = 0;
										_f_list = _tmp41_;
										_tmp44_ = _f_list;
										_tmp45_ = vala_collection_get_size ((ValaCollection*) _tmp44_);
										_tmp46_ = _tmp45_;
										_f_size = _tmp46_;
										_f_index = -1;
										while (TRUE) {
											gint _tmp47_;
											gint _tmp48_;
											GFile* f = NULL;
											ValaArrayList* _tmp49_;
											gpointer _tmp50_;
											gchar* name = NULL;
											const gchar* _tmp51_;
											GFile* _tmp52_;
											GFile* _tmp53_;
											gchar* _tmp54_;
											gchar* _tmp55_;
											gchar* _tmp56_;
											gchar* _tmp57_;
											ValaArrayList* _tmp58_;
											GFile* _tmp59_;
											const gchar* _tmp60_;
											GEqualFunc _tmp61_;
											ValaArrayList* _tmp62_;
											ValaArrayList* _tmp63_;
											ValaLintFileData _tmp64_ = {0};
											_f_index = _f_index + 1;
											_tmp47_ = _f_index;
											_tmp48_ = _f_size;
											if (!(_tmp47_ < _tmp48_)) {
												break;
											}
											_tmp49_ = _f_list;
											_tmp50_ = vala_list_get ((ValaList*) _tmp49_, _f_index);
											f = (GFile*) _tmp50_;
											_tmp51_ = path;
											_tmp52_ = file;
											_tmp53_ = f;
											_tmp54_ = g_file_get_relative_path (_tmp52_, _tmp53_);
											_tmp55_ = _tmp54_;
											_tmp56_ = g_strconcat (_tmp51_, _tmp55_, NULL);
											_tmp57_ = _tmp56_;
											_g_free0 (_tmp55_);
											name = _tmp57_;
											_tmp58_ = _result_;
											_tmp59_ = f;
											_tmp60_ = name;
											_tmp61_ = g_direct_equal;
											_tmp62_ = vala_array_list_new (VALA_LINT_TYPE_FORMAT_MISTAKE, (GBoxedCopyFunc) _vala_lint_format_mistake_dup, (GDestroyNotify) _vala_ValaLintFormatMistake_free, _tmp61_);
											_tmp63_ = _tmp62_;
											_g_object_unref0 (_tmp64_.file);
											_tmp64_.file = _tmp59_;
											_g_free0 (_tmp64_.name);
											_tmp64_.name = _tmp60_;
											_vala_iterable_unref0 (_tmp64_.mistakes);
											_tmp64_.mistakes = _tmp63_;
											vala_collection_add ((ValaCollection*) _tmp58_, &_tmp64_);
											_vala_iterable_unref0 (_tmp63_);
											_g_free0 (name);
											_g_object_unref0 (f);
										}
									}
									_vala_iterable_unref0 (_tmp41_);
									break;
								}
								default:
								{
									break;
								}
							}
							_g_object_unref0 (file);
							_g_free0 (path);
						}
					}
				}
				globfree (&matcher);
				_g_free0 (pattern);
			}
		}
	}
	result = _result_;
	return result;
}

static ValaArrayList*
vala_lint_application_get_files_from_directory (ValaLintApplication* self,
                                                GFile* dir,
                                                GError** error)
{
	ValaArrayList* files = NULL;
	GEqualFunc _tmp0_;
	ValaArrayList* _tmp1_;
	GFileEnumerator* enumerator = NULL;
	GFileEnumerator* _tmp2_;
	GFileInfo* info = NULL;
	GFileEnumerator* _tmp3_;
	GFileInfo* _tmp4_;
	GError* _inner_error0_ = NULL;
	ValaArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (dir != NULL, NULL);
	_tmp0_ = g_direct_equal;
	_tmp1_ = vala_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp0_);
	files = _tmp1_;
	_tmp2_ = g_file_enumerate_children (dir, G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_IS_HIDDEN, 0, NULL, &_inner_error0_);
	enumerator = _tmp2_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_vala_iterable_unref0 (files);
		return NULL;
	}
	_tmp3_ = enumerator;
	_tmp4_ = g_file_enumerator_next_file (_tmp3_, NULL, &_inner_error0_);
	info = _tmp4_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (enumerator);
		_vala_iterable_unref0 (files);
		return NULL;
	}
	while (TRUE) {
		GFileInfo* _tmp5_;
		gchar* child_name = NULL;
		GFileInfo* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		GFile* child_file = NULL;
		const gchar* _tmp9_;
		GFile* _tmp10_;
		gchar* rel_path = NULL;
		GFile* _tmp11_;
		GFile* _tmp12_;
		gchar* _tmp13_;
		gboolean _tmp14_ = FALSE;
		GFileInfo* _tmp15_;
		GFileInfo* _tmp30_ = NULL;
		GFileEnumerator* _tmp31_;
		GFileInfo* _tmp32_;
		GFileInfo* _tmp33_;
		_tmp5_ = info;
		if (!(_tmp5_ != NULL)) {
			break;
		}
		_tmp6_ = info;
		_tmp7_ = g_file_info_get_name (_tmp6_);
		_tmp8_ = g_strdup (_tmp7_);
		child_name = _tmp8_;
		_tmp9_ = child_name;
		_tmp10_ = g_file_resolve_relative_path (dir, _tmp9_);
		child_file = _tmp10_;
		_tmp11_ = vala_lint_application_root_dir;
		_tmp12_ = child_file;
		_tmp13_ = g_file_get_relative_path (_tmp11_, _tmp12_);
		rel_path = _tmp13_;
		_tmp15_ = info;
		if (!g_file_info_get_is_hidden (_tmp15_)) {
			const gchar* _tmp16_;
			const gchar* _tmp17_;
			_tmp16_ = vala_lint_application_ignore_pattern_list;
			_tmp17_ = rel_path;
			_tmp14_ = fnmatch (_tmp16_, _tmp17_, vala_lint_application_fnmatch_flags) != 0;
		} else {
			_tmp14_ = FALSE;
		}
		if (_tmp14_) {
			GFileInfo* _tmp18_;
			_tmp18_ = info;
			if (g_file_info_get_file_type (_tmp18_) == G_FILE_TYPE_DIRECTORY) {
				ValaArrayList* sub_files = NULL;
				GFile* _tmp19_;
				ValaArrayList* _tmp20_;
				ValaArrayList* _tmp21_;
				ValaArrayList* _tmp22_;
				_tmp19_ = child_file;
				_tmp20_ = vala_lint_application_get_files_from_directory (self, _tmp19_, &_inner_error0_);
				sub_files = _tmp20_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					g_propagate_error (error, _inner_error0_);
					_g_free0 (rel_path);
					_g_object_unref0 (child_file);
					_g_free0 (child_name);
					_g_object_unref0 (info);
					_g_object_unref0 (enumerator);
					_vala_iterable_unref0 (files);
					return NULL;
				}
				_tmp21_ = files;
				_tmp22_ = sub_files;
				vala_collection_add_all ((ValaCollection*) _tmp21_, (ValaCollection*) _tmp22_);
				_vala_iterable_unref0 (sub_files);
			} else {
				gboolean _tmp23_ = FALSE;
				GFileInfo* _tmp24_;
				_tmp24_ = info;
				if (g_file_info_get_file_type (_tmp24_) == G_FILE_TYPE_REGULAR) {
					const gchar* _tmp25_;
					_tmp25_ = child_name;
					_tmp23_ = g_str_has_suffix (_tmp25_, ".vala");
				} else {
					_tmp23_ = FALSE;
				}
				if (_tmp23_) {
					ValaArrayList* _tmp26_;
					GFile* _tmp27_;
					_tmp26_ = files;
					_tmp27_ = child_file;
					vala_collection_add ((ValaCollection*) _tmp26_, _tmp27_);
				} else {
					const gchar* _tmp28_;
					_tmp28_ = child_name;
					g_debug ("Application.vala:289: %s ignored - not regular Vala file", _tmp28_);
				}
			}
		} else {
			const gchar* _tmp29_;
			_tmp29_ = rel_path;
			g_debug ("Application.vala:292: %s ignored - hidden or matches ignore pattern", _tmp29_);
		}
		_tmp31_ = enumerator;
		_tmp32_ = g_file_enumerator_next_file (_tmp31_, NULL, &_inner_error0_);
		_tmp30_ = _tmp32_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (rel_path);
			_g_object_unref0 (child_file);
			_g_free0 (child_name);
			_g_object_unref0 (info);
			_g_object_unref0 (enumerator);
			_vala_iterable_unref0 (files);
			return NULL;
		}
		_tmp33_ = _tmp30_;
		_tmp30_ = NULL;
		_g_object_unref0 (info);
		info = _tmp33_;
		_g_object_unref0 (_tmp30_);
		_g_free0 (rel_path);
		_g_object_unref0 (child_file);
		_g_free0 (child_name);
	}
	result = files;
	_g_object_unref0 (info);
	_g_object_unref0 (enumerator);
	return result;
}

static gboolean
vala_lint_application_print_mistakes (ValaLintApplication* self,
                                      ValaArrayList* file_data_list)
{
	gint num_errors = 0;
	gint num_warnings = 0;
	const gchar* _tmp78_ = NULL;
	const gchar* _tmp79_ = NULL;
	gchar* summary = NULL;
	gchar* _tmp80_;
	gchar* _tmp81_;
	gchar* _tmp82_;
	gchar* _tmp83_;
	gchar* _tmp84_;
	gchar* _tmp85_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (file_data_list != NULL, FALSE);
	num_errors = 0;
	num_warnings = 0;
	{
		ValaArrayList* _file_data_list = NULL;
		gint _file_data_size = 0;
		ValaArrayList* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		gint _file_data_index = 0;
		_file_data_list = file_data_list;
		_tmp0_ = _file_data_list;
		_tmp1_ = vala_collection_get_size ((ValaCollection*) _tmp0_);
		_tmp2_ = _tmp1_;
		_file_data_size = _tmp2_;
		_file_data_index = -1;
		while (TRUE) {
			gint _tmp3_;
			gint _tmp4_;
			ValaLintFileData file_data = {0};
			ValaArrayList* _tmp5_;
			gpointer _tmp6_;
			ValaLintFileData* _tmp7_;
			ValaLintFileData _tmp8_;
			ValaLintFileData _tmp9_ = {0};
			ValaLintFileData _tmp10_;
			ValaLintFileData _tmp11_;
			ValaArrayList* _tmp12_;
			gboolean _tmp13_;
			gboolean _tmp14_;
			_file_data_index = _file_data_index + 1;
			_tmp3_ = _file_data_index;
			_tmp4_ = _file_data_size;
			if (!(_tmp3_ < _tmp4_)) {
				break;
			}
			_tmp5_ = _file_data_list;
			_tmp6_ = vala_list_get ((ValaList*) _tmp5_, _file_data_index);
			_tmp7_ = (ValaLintFileData*) _tmp6_;
			_tmp8_ = *_tmp7_;
			vala_lint_file_data_copy (&_tmp8_, &_tmp9_);
			_tmp10_ = _tmp9_;
			_vala_lint_file_data_free0 (_tmp7_);
			file_data = _tmp10_;
			_tmp11_ = file_data;
			_tmp12_ = _tmp11_.mistakes;
			_tmp13_ = vala_collection_get_is_empty ((ValaCollection*) _tmp12_);
			_tmp14_ = _tmp13_;
			if (!_tmp14_) {
				GApplicationCommandLine* _tmp15_;
				ValaLintFileData _tmp16_;
				const gchar* _tmp17_;
				_tmp15_ = self->priv->application_command_line;
				_tmp16_ = file_data;
				_tmp17_ = _tmp16_.name;
				g_application_command_line_print (_tmp15_, "\x001b[1m\x001b[4m" "%s" "\x001b[0m\n", _tmp17_);
				{
					ValaArrayList* _mistake_list = NULL;
					ValaLintFileData _tmp18_;
					ValaArrayList* _tmp19_;
					gint _mistake_size = 0;
					ValaArrayList* _tmp20_;
					gint _tmp21_;
					gint _tmp22_;
					gint _mistake_index = 0;
					_tmp18_ = file_data;
					_tmp19_ = _tmp18_.mistakes;
					_mistake_list = _tmp19_;
					_tmp20_ = _mistake_list;
					_tmp21_ = vala_collection_get_size ((ValaCollection*) _tmp20_);
					_tmp22_ = _tmp21_;
					_mistake_size = _tmp22_;
					_mistake_index = -1;
					while (TRUE) {
						gint _tmp23_;
						gint _tmp24_;
						ValaLintFormatMistake mistake = {0};
						ValaArrayList* _tmp25_;
						gpointer _tmp26_;
						ValaLintFormatMistake* _tmp27_;
						ValaLintFormatMistake _tmp28_;
						ValaLintFormatMistake _tmp29_ = {0};
						ValaLintFormatMistake _tmp30_;
						ValaLintFormatMistake _tmp31_;
						ValaLintCheck* _tmp32_;
						ValaLintConfigState _tmp33_;
						ValaLintConfigState _tmp34_;
						gchar* color_state = NULL;
						gchar* _tmp37_;
						gchar* mistakes_end = NULL;
						gchar* _tmp38_;
						const gchar* _tmp44_;
						ValaLintFormatMistake _tmp45_;
						ValaLintCheck* _tmp46_;
						ValaLintConfigState _tmp47_;
						ValaLintConfigState _tmp48_;
						gchar* _tmp49_;
						GApplicationCommandLine* _tmp50_;
						const gchar* _tmp51_;
						gchar* _tmp52_;
						gchar* _tmp53_;
						gchar* _tmp54_;
						gchar* _tmp55_;
						ValaLintFormatMistake _tmp56_;
						ValaSourceLocation _tmp57_;
						ValaLintFormatMistake _tmp58_;
						ValaSourceLocation _tmp59_;
						const gchar* _tmp60_;
						ValaLintFormatMistake _tmp61_;
						ValaLintCheck* _tmp62_;
						ValaLintConfigState _tmp63_;
						ValaLintConfigState _tmp64_;
						gchar* _tmp65_;
						gchar* _tmp66_;
						ValaLintFormatMistake _tmp67_;
						const gchar* _tmp68_;
						ValaLintFormatMistake _tmp69_;
						ValaLintCheck* _tmp70_;
						const gchar* _tmp71_;
						const gchar* _tmp72_;
						_mistake_index = _mistake_index + 1;
						_tmp23_ = _mistake_index;
						_tmp24_ = _mistake_size;
						if (!(_tmp23_ < _tmp24_)) {
							break;
						}
						_tmp25_ = _mistake_list;
						_tmp26_ = vala_list_get ((ValaList*) _tmp25_, _mistake_index);
						_tmp27_ = (ValaLintFormatMistake*) _tmp26_;
						_tmp28_ = *_tmp27_;
						vala_lint_format_mistake_copy (&_tmp28_, &_tmp29_);
						_tmp30_ = _tmp29_;
						__vala_ValaLintFormatMistake_free0 (_tmp27_);
						mistake = _tmp30_;
						_tmp31_ = mistake;
						_tmp32_ = _tmp31_.check;
						_tmp33_ = vala_lint_check_get_state (_tmp32_);
						_tmp34_ = _tmp33_;
						switch (_tmp34_) {
							case VALA_LINT_CONFIG_STATE_ERROR:
							{
								gint _tmp35_;
								_tmp35_ = num_errors;
								num_errors = _tmp35_ + 1;
								break;
							}
							case VALA_LINT_CONFIG_STATE_WARN:
							{
								gint _tmp36_;
								_tmp36_ = num_warnings;
								num_warnings = _tmp36_ + 1;
								break;
							}
							default:
							{
								break;
							}
						}
						_tmp37_ = g_strdup ("%-5s");
						color_state = _tmp37_;
						_tmp38_ = g_strdup ("");
						mistakes_end = _tmp38_;
						if (vala_lint_application_print_mistakes_end) {
							ValaLintFormatMistake _tmp39_;
							ValaSourceLocation _tmp40_;
							ValaLintFormatMistake _tmp41_;
							ValaSourceLocation _tmp42_;
							gchar* _tmp43_;
							_tmp39_ = mistake;
							_tmp40_ = _tmp39_.end;
							_tmp41_ = mistake;
							_tmp42_ = _tmp41_.end;
							_tmp43_ = g_strdup_printf ("-%5i.%-3i", _tmp40_.line, _tmp42_.column);
							_g_free0 (mistakes_end);
							mistakes_end = _tmp43_;
						}
						_tmp44_ = color_state;
						_tmp45_ = mistake;
						_tmp46_ = _tmp45_.check;
						_tmp47_ = vala_lint_check_get_state (_tmp46_);
						_tmp48_ = _tmp47_;
						_tmp49_ = vala_lint_application_apply_color_for_state (self, _tmp44_, _tmp48_);
						_g_free0 (color_state);
						color_state = _tmp49_;
						_tmp50_ = self->priv->application_command_line;
						_tmp51_ = color_state;
						_tmp52_ = g_strconcat ("\x001b[0m%5i.%-3i %s  ", _tmp51_, NULL);
						_tmp53_ = _tmp52_;
						_tmp54_ = g_strconcat (_tmp53_, "   %-45s   \033[2m%s\033[0m\n", NULL);
						_tmp55_ = _tmp54_;
						_tmp56_ = mistake;
						_tmp57_ = _tmp56_.begin;
						_tmp58_ = mistake;
						_tmp59_ = _tmp58_.begin;
						_tmp60_ = mistakes_end;
						_tmp61_ = mistake;
						_tmp62_ = _tmp61_.check;
						_tmp63_ = vala_lint_check_get_state (_tmp62_);
						_tmp64_ = _tmp63_;
						_tmp65_ = vala_lint_config_state_to_string (_tmp64_);
						_tmp66_ = _tmp65_;
						_tmp67_ = mistake;
						_tmp68_ = _tmp67_.mistake;
						_tmp69_ = mistake;
						_tmp70_ = _tmp69_.check;
						_tmp71_ = vala_lint_check_get_title (_tmp70_);
						_tmp72_ = _tmp71_;
						g_application_command_line_print (_tmp50_, _tmp55_, _tmp57_.line, _tmp59_.column, _tmp60_, _tmp66_, _tmp68_, _tmp72_);
						_g_free0 (_tmp66_);
						_g_free0 (_tmp55_);
						_g_free0 (_tmp53_);
						_g_free0 (mistakes_end);
						_g_free0 (color_state);
						vala_lint_format_mistake_destroy (&mistake);
					}
				}
			}
			vala_lint_file_data_destroy (&file_data);
		}
	}
	if ((num_errors + num_warnings) == 0) {
		GApplicationCommandLine* _tmp73_;
		gchar* _tmp74_;
		gchar* _tmp75_;
		gchar* _tmp76_;
		gchar* _tmp77_;
		_tmp73_ = self->priv->application_command_line;
		_tmp74_ = g_strconcat ("\033[1;32m", _ ("No mistakes found"), NULL);
		_tmp75_ = _tmp74_;
		_tmp76_ = g_strconcat (_tmp75_, "\033[0m\n", NULL);
		_tmp77_ = _tmp76_;
		g_application_command_line_print (_tmp73_, "%s", _tmp77_);
		_g_free0 (_tmp77_);
		_g_free0 (_tmp75_);
		result = FALSE;
		return result;
	}
	if (num_errors == 1) {
		_tmp78_ = _ ("error");
	} else {
		_tmp78_ = _ ("errors");
	}
	if (num_warnings == 1) {
		_tmp79_ = _ ("warning");
	} else {
		_tmp79_ = _ ("warnings");
	}
	_tmp80_ = g_strconcat ("\n", _ ("%d %s, %d %s"), NULL);
	_tmp81_ = _tmp80_;
	_tmp82_ = g_strconcat (_tmp81_, "\n", NULL);
	_tmp83_ = _tmp82_;
	_tmp84_ = g_strdup_printf (_tmp83_, num_errors, _tmp78_, num_warnings, _tmp79_);
	_tmp85_ = _tmp84_;
	_g_free0 (_tmp83_);
	_g_free0 (_tmp81_);
	summary = _tmp85_;
	if (num_errors > 0) {
		GApplicationCommandLine* _tmp86_;
		const gchar* _tmp87_;
		gchar* _tmp88_;
		gchar* _tmp89_;
		_tmp86_ = self->priv->application_command_line;
		_tmp87_ = summary;
		_tmp88_ = vala_lint_application_apply_color_for_state (self, _tmp87_, VALA_LINT_CONFIG_STATE_ERROR);
		_tmp89_ = _tmp88_;
		g_application_command_line_print (_tmp86_, "%s", _tmp89_);
		_g_free0 (_tmp89_);
	} else {
		GApplicationCommandLine* _tmp90_;
		const gchar* _tmp91_;
		gchar* _tmp92_;
		gchar* _tmp93_;
		_tmp90_ = self->priv->application_command_line;
		_tmp91_ = summary;
		_tmp92_ = vala_lint_application_apply_color_for_state (self, _tmp91_, VALA_LINT_CONFIG_STATE_WARN);
		_tmp93_ = _tmp92_;
		g_application_command_line_print (_tmp90_, "%s", _tmp93_);
		_g_free0 (_tmp93_);
	}
	result = num_errors > 0;
	_g_free0 (summary);
	return result;
}

static gchar*
vala_lint_application_apply_color_for_state (ValaLintApplication* self,
                                             const gchar* str,
                                             ValaLintConfigState state)
{
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (str != NULL, NULL);
	switch (state) {
		case VALA_LINT_CONFIG_STATE_ERROR:
		{
			gchar* _tmp0_;
			gchar* _tmp1_;
			gchar* _tmp2_;
			gchar* _tmp3_;
			_tmp0_ = g_strconcat ("\033[1;31m", str, NULL);
			_tmp1_ = _tmp0_;
			_tmp2_ = g_strconcat (_tmp1_, "\033[0m", NULL);
			_tmp3_ = _tmp2_;
			_g_free0 (_tmp1_);
			result = _tmp3_;
			return result;
		}
		case VALA_LINT_CONFIG_STATE_WARN:
		{
			gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			_tmp4_ = g_strconcat ("\033[1;33m", str, NULL);
			_tmp5_ = _tmp4_;
			_tmp6_ = g_strconcat (_tmp5_, "\033[0m", NULL);
			_tmp7_ = _tmp6_;
			_g_free0 (_tmp5_);
			result = _tmp7_;
			return result;
		}
		default:
		{
			gchar* _tmp8_;
			_tmp8_ = g_strdup (str);
			result = _tmp8_;
			return result;
		}
	}
}

static gint
vala_lint_application_main (gchar** args,
                            gint args_length1)
{
	ValaLintApplication* _tmp0_;
	ValaLintApplication* _tmp1_;
	gint _tmp2_;
	gint result;
	_tmp0_ = vala_lint_application_new ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_application_run ((GApplication*) _tmp1_, (gint) args_length1, args);
	_g_object_unref0 (_tmp1_);
	result = _tmp2_;
	return result;
}

int
main (int argc,
      char ** argv)
{
	return vala_lint_application_main (argv, argc);
}

static void
vala_lint_application_class_init (ValaLintApplicationClass * klass,
                                  gpointer klass_data)
{
	gchar* _tmp0_;
	vala_lint_application_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ValaLintApplication_private_offset);
	((GApplicationClass *) klass)->command_line = (gint (*) (GApplication*, GApplicationCommandLine*)) vala_lint_application_real_command_line;
	G_OBJECT_CLASS (klass)->finalize = vala_lint_application_finalize;
	_tmp0_ = g_strdup ("");
	vala_lint_application_ignore_pattern_list = _tmp0_;
}

static void
vala_lint_application_instance_init (ValaLintApplication * self,
                                     gpointer klass)
{
	self->priv = vala_lint_application_get_instance_private (self);
}

static void
vala_lint_application_finalize (GObject * obj)
{
	ValaLintApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_LINT_TYPE_APPLICATION, ValaLintApplication);
	_g_object_unref0 (self->priv->application_command_line);
	G_OBJECT_CLASS (vala_lint_application_parent_class)->finalize (obj);
}

static GType
vala_lint_application_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ValaLintApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_lint_application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaLintApplication), 0, (GInstanceInitFunc) vala_lint_application_instance_init, NULL };
	GType vala_lint_application_type_id;
	vala_lint_application_type_id = g_type_register_static (g_application_get_type (), "ValaLintApplication", &g_define_type_info, 0);
	ValaLintApplication_private_offset = g_type_add_instance_private (vala_lint_application_type_id, sizeof (ValaLintApplicationPrivate));
	return vala_lint_application_type_id;
}

GType
vala_lint_application_get_type (void)
{
	static volatile gsize vala_lint_application_type_id__once = 0;
	if (g_once_init_enter (&vala_lint_application_type_id__once)) {
		GType vala_lint_application_type_id;
		vala_lint_application_type_id = vala_lint_application_get_type_once ();
		g_once_init_leave (&vala_lint_application_type_id__once, vala_lint_application_type_id);
	}
	return vala_lint_application_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

